import * as React from 'react';
import { ApiTableProps } from './interface';
/***
 * API Table 使用说明
*/
export default class extends React.PureComponent<ApiTableProps> {
    rowKey: any;
    api: string;
    columns: any[];
    param: any;
    state: {
        loading: boolean;
        list: any[];
        total: number;
        pageSize: number;
        current: number;
        totalAcc: number;
        selectedRowKeys: any[];
        selectObjects: any[];
    };
    constructor(props: any);
    setColumn(): void;
    componentDidMount(): void;
    componentDidUpdate(old: any): void;
    private _query;
    cleanAndQuery: (param: any) => void;
    query: (param: any) => void;
    clear: () => void;
    add: (data: any) => boolean;
    update: (data: any) => boolean;
    remove: (data: any) => boolean;
    private renderSearchBar;
    private renderTable;
    private toPage;
    private sort;
    private renderPagination;
    render(): JSX.Element;
}
