"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var DTree_1 = require("../UTree/DTree");
// 组织机构的选择器
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    default_1.prototype.render = function () {
        var _this = this;
        return React.createElement(DTree_1.DTree, { api: '', rootApi: this.props.useRoot ? '/api-common/organization/root' : '/api-common/organization/rootinfo', childApi: "/api-common/organization/tree/", keyField: 'code', titleField: 'name', parentField: 'parentCode', checkField: "hasChildren", onSelect: function (node, parent) {
                if (node) {
                    _this.props.onSelect(node, parent);
                }
                else {
                    _this.props.onSelect(null);
                }
            } });
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
