"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var antd_1 = require("antd");
var React = require("react");
var _ = require("lodash");
var utils_1 = require("../../utils");
var SearchBar_1 = require("../Table/SearchBar");
var UPagination_1 = require("../UPagination");
/***
 * ES Table 使用说明
 *
*/
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1(props) {
        var _this = _super.call(this, props) || this;
        _this.id = 'id_' + _.random(999999);
        _this.api = '/api-search/search/content/search';
        _this.timeField = 'event_time';
        _this.typeName = 'logs';
        _this.columns = []; // 列
        _this.BaseQuery = { and: {}, or: {}, not: {} };
        _this.and = {};
        _this.fields = [];
        _this.fieldMap = new Map();
        _this.state = {
            loading: false,
            list: [],
            total: 0,
            totalAcc: 0,
            pageSize: _this.props.pageSize || window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT,
            order: '',
            by: 'DESC',
            current: 1, // 当前页数
        };
        _this.cleanAndQuery = function (param) {
            _this.setState({ list: [], total: 0, totalAcc: 0, current: 1 });
            _this.query(param);
        };
        // 仅支持 AND
        _this.query = function (param) {
            _this.and = _.assign({}, _this.BaseQuery.and, param);
            _this.setState({ current: 1 }, function () { return _this._query(); });
        };
        _this.setDefault();
        _this.setColumn();
        return _this;
    }
    default_1.prototype.setColumn = function () {
        var _this = this;
        this.columns = _.concat([], _.filter(this.props.columns, function (item) { return item.show === undefined || item.show == true; }));
        if (this.props.showIndex !== false) {
            if (this.props.showIndex === undefined) {
                var _indexItem = {
                    title: React.createElement("span", null, "\u5E8F\u53F7"),
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                };
                this.columns.unshift(_indexItem);
            }
            else if (_.isString(this.props.showIndex)) {
                var _indexItem = {
                    title: React.createElement("span", null, this.props.showIndex),
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                };
                this.columns.unshift(_indexItem);
            }
        }
    };
    default_1.prototype.setDefault = function () {
        this.api = _.has(this.props, 'query') ? this.props.query : '/api-search/search/content/search';
        this.timeField = this.props.timeField || 'event_time';
        this.typeName = this.props.typeName || 'logs';
        if (_.has(this.props, 'default')) {
            this.BaseQuery.and = _.assign({}, this.props.default.and);
            this.BaseQuery.or = _.assign({}, this.props.default.or);
            this.BaseQuery.not = _.assign({}, this.props.default.not);
            this.and = _.assign({}, this.BaseQuery.and);
        }
    };
    default_1.prototype.componentDidMount = function () {
        if (this.props.autoLoad === false) {
            return;
        }
        this.query({});
    };
    default_1.prototype.componentDidUpdate = function (old) {
        // @ts-ignore
        if (this.props.modalMode) {
            return;
        }
        var needQuery = false;
        if (this.api != this.props.query || !_.isEqual(old.default, this.props.default)) {
            this.api = this.props.query;
            needQuery = true;
        }
        if (old.columns != this.props.columns) {
            this.setColumn();
        }
        if (this.props.timeField != old.timeField || this.props.startTime != old.startTime || this.props.endTime != old.endTime || this.props.typeName != old.typeName || this.props.indexName != old.indexName) {
            needQuery = true;
        }
        if (needQuery) {
            if (this.props.needQuery === false) {
                return;
            }
            this.query({});
        }
    };
    default_1.prototype._query = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, VLIST, RESULT, _b, current, pageSize, order, by, _c, startTime, endTime, and, _query, resultFields, indexName, Query, resp, total, totalAcc, list;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = window.VAP_GLOBAL, VLIST = _a.VLIST, RESULT = _a.RESULT;
                        this.setState({ loading: true });
                        _b = this.state, current = _b.current, pageSize = _b.pageSize, order = _b.order, by = _b.by;
                        _c = this.props, startTime = _c.startTime, endTime = _c.endTime;
                        and = _.assign({}, this.BaseQuery.and, this.and);
                        _.keys(and).map(function (key) {
                            if (_.isEmpty(and[key]) && !_.isNumber(and[key])) {
                                _.unset(and, key);
                            }
                        });
                        _query = { and: and, or: this.BaseQuery.or, not: this.BaseQuery.not };
                        resultFields = this.props.columns.map(function (item) { return item.dataIndex; });
                        if (resultFields.indexOf(this.props.timeField) < 0) {
                            resultFields.push(this.props.timeField);
                        }
                        indexName = this.props.indexName;
                        if (indexName.endsWith('-*')) {
                            indexName = indexName.substr(0, indexName.length - 2);
                        }
                        Query = {
                            start_: (current - 1) * pageSize,
                            count_: pageSize,
                            indexName: indexName,
                            resultFields: resultFields,
                            sortFields: [order || this.timeField],
                            sortOrder: by,
                            timeField: this.timeField,
                            typeName: this.typeName,
                            startTime: startTime,
                            endTime: endTime,
                            query: JSON.stringify(_query),
                        };
                        this.setState({ loading: true });
                        return [4 /*yield*/, utils_1.Ajax.POST(this.api, Query)];
                    case 1:
                        resp = _d.sent();
                        if (resp[RESULT.code] == resp[RESULT.success] || resp[RESULT.code] == null || resp[RESULT.code] == '') {
                            total = resp[VLIST.total];
                            totalAcc = resp[VLIST.totalAcc] || total;
                            list = resp[VLIST.list] || [];
                            this.setState({ total: total, totalAcc: totalAcc, list: list, loading: false });
                        }
                        else {
                            antd_1.message.error(resp[RESULT.message]);
                            this.setState({ total: 0, totalAcc: 0, list: [], loading: false });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    default_1.prototype.clear = function () {
        this.setState({ list: [], total: 0, totalAcc: 0, current: 1, loading: false, });
    };
    default_1.prototype.renderSearchBar = function () {
        var _this = this;
        if (!_.has(this.props, 'searchBar')) {
            return [];
        }
        var fields = this.props.searchBar.fields;
        if (fields.length == 0) {
            return [];
        }
        var param = __assign(__assign({}, this.props.searchBar), { onSearch: function (param) { return _this.query(param); }, default: this.BaseQuery.and, param: this.and, 
            // @ts-ignore
            modalMode: this.props.modalMode });
        return React.createElement(SearchBar_1.default, __assign({}, param));
    };
    default_1.prototype.renderTable = function () {
        var _this = this;
        return React.createElement(antd_1.Table, __assign({}, this.props, { dataSource: this.state.list, onChange: function (pagination, filters, sorter) { return _this.sort(sorter); }, size: "small", columns: this.columns, loading: this.state.loading, 
            // rowClassName={item => _.has(item, '__EFFECT') ? 'row-high-' + item['__EFFECT'] : ''}
            pagination: false, locale: { emptyText: React.createElement(antd_1.Empty, null) } }));
    };
    default_1.prototype.toPage = function (current, pageSize) {
        var _this = this;
        this.setState({ current: current, pageSize: pageSize }, function () { return _this._query(); });
    };
    default_1.prototype.sort = function (sorter) {
        var _this = this;
        var order = this.timeField;
        var by = 'DESC';
        if (_.has(sorter, 'field')) {
            order = sorter.field;
            by = (sorter.order == 'ascend' ? 'ASC' : 'DESC');
        }
        this.setState({ order: order, by: by }, function () { return _this._query(); });
    };
    default_1.prototype.renderPagination = function () {
        var _this = this;
        var _a = this.state, total = _a.total, list = _a.list, totalAcc = _a.totalAcc;
        var OPTIONS = window.VAP_GLOBAL.PAGINATION.OPTIONS;
        return React.createElement(UPagination_1.default, { onChange: function (page, pageSize) { return _this.toPage(page, pageSize); }, onShowSizeChange: function (page, pageSize) { return _this.toPage(page, pageSize); }, current: this.state.current, total: total, pageSize: this.state.pageSize, pageSizeOptions: OPTIONS });
    };
    default_1.prototype.render = function () {
        var className = ["vap-table"];
        // @ts-ignore
        if (this.props.modalMode) {
            className.push('vap-table-inner');
        }
        if (this.props.className) {
            className.push(this.props.className);
        }
        return React.createElement(antd_1.Layout, { className: className.join(' ') },
            this.renderSearchBar(),
            React.createElement(antd_1.Layout, null,
                React.createElement(antd_1.Layout.Content, { className: "vap-table-content" }, this.renderTable()),
                (this.props.pagination === false || this.props.pagination === null) ? [] : React.createElement(antd_1.Layout.Footer, { className: "vap-table-footer" }, this.renderPagination())));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
