"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var DynamicTreeXj_1 = require("../VTree/DynamicTreeXj");
// 安全域选择器
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tree = null;
        _this.state = {
            show: false,
            currentNode: null,
            treeData: [],
        };
        return _this;
    }
    default_1.prototype.componentDidMount = function () {
        if (this.props.domainInfo && this.props.domainInfo.code) {
            if (this.props.mode == 'search')
                this.setState({ currentNode: this.props.domainInfo.code });
            else
                this.setState({ currentNode: this.props.domainInfo });
        }
    };
    default_1.prototype.show = function () {
        this.setState({ show: true });
    };
    default_1.prototype.onChooseNode = function (currentNode) {
        this.setState({ show: false });
        this.props.onSelect(currentNode);
    };
    default_1.prototype.clear = function () {
        this.tree.clearSelect();
        this.setState({ currentNode: null });
        this.props.onClear && this.props.onClear();
    };
    default_1.prototype.render = function () {
        var _this = this;
        var param = {};
        if (this.props.domainInfo && this.props.domainInfo.code) {
            param = {
                defaultSelectedKeys: [this.props.domainInfo.code],
            };
        }
        return React.createElement(antd_1.Modal, { visible: this.state.show, title: '请选择区域', footer: React.createElement("div", null,
                React.createElement("div", null,
                    React.createElement(antd_1.Button, { disabled: this.props.required && this.state.currentNode == null, type: "primary", onClick: function () { return _this.onChooseNode(_this.state.currentNode); } }, "\u786E\u5B9A"),
                    this.props.onClear && React.createElement(antd_1.Button, { style: { marginLeft: 12 }, onClick: function () { _this.setState({ currentNode: null }); _this.props.onClear && _this.props.onClear(); _this.setState({ show: false }); _this.tree.clearSelect(); } }, "\u6E05\u7A7A"))), onCancel: function () { return _this.setState({ show: false }); } },
            React.createElement(antd_1.Affix, { offsetTop: 10 }, this.state.currentNode && React.createElement("div", { style: { marginBottom: 10 } },
                React.createElement("span", null,
                    " ",
                    React.createElement("b", null,
                        "\u5DF2\u9009\u62E9 : ",
                        this.props.multiple ? this.state.currentNode.map(function (item, index) {
                            return React.createElement("span", null,
                                item.domainName,
                                ",");
                        }) : this.state.currentNode.domainName)))),
            React.createElement(DynamicTreeXj_1.default, __assign({ style: { height: 300, overflow: 'auto' }, mode: this.props.mode }, param, { multiple: this.props.multiple, ref: function (tree) { return _this.tree = tree; }, mustSelect: this.props.required, root: "/api-common/secruity/domain/all", child: "/api-common/secruity/domain/", onSelect: function (currentNode) {
                    if (currentNode) {
                        _this.setState({ currentNode: currentNode });
                    }
                    else {
                        _this.props.onSelect({ currentNode: null });
                    }
                }, keyField: 'code', nameField: 'domainName', parentField: 'parentCode', checkChild: "hasChildren" })));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
