import * as React from "react";
/**
 * 为了适配部分皮肤的内容区域的间距问题
*/
export interface RootBoxProps {
    /**
     * 样式
    */
    style?: React.CSSProperties;
    /**
     * 自定义 class 名
    */
    className?: string;
    /**
     * 全屏模式，默认 false
    */
    fixed?: boolean;
    /**
     * 顶头模式，默认 false
    */
    header?: boolean;
}
