import * as React from 'react';
import { STablePOpts } from './interface';
/**
 * STable ： 数据Table组件
 * 相当于 VTable 的静态版本
 * STable 不支持REF方法
*/
declare class STable extends React.PureComponent<STablePOpts, any> {
    mode: string;
    id: any;
    rowKey: any;
    param: any;
    columns: any[];
    initColumns: any[];
    state: {
        data: any[];
        total: number;
        pageSize: any;
        showCustom: boolean;
        selectedRowKeys: any[];
        selectObjects: any[];
        current: number;
        maxHeight: number;
        customTemp: {};
    };
    private fetchData;
    constructor(props: any);
    componentDidMount(): void;
    componentDidUpdate(prevProps: Readonly<STablePOpts>): void;
    /**
     * 查询
     *  */
    query: (param: any) => void;
    private onSelect;
    private renderSelectBar;
    private reMax;
    private renderSearchBar;
    private sorterField;
    private toPage;
    private renderTable;
    private renderPagination;
    render(): JSX.Element;
}
declare const _default: typeof STable;
export default _default;
