"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../../utils");
var _ = require("lodash");
var __SERVICES = new Set();
var __loaded = false;
utils_1.Ajax.SESION('/api-common/services');
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    default_1.prototype.componentWillMount = function () {
        var _this = this;
        if (!__loaded) {
            utils_1.Ajax.GET('/api-common/services', function (json) {
                __loaded = true;
                if (_.isArray(json.data) && json.data.length > 0) {
                    json.data.map(function (serviceId) { return __SERVICES.add(_.trim(_.toLower(serviceId))); });
                }
                _this.setState({ t: new Date().getTime() });
            });
        }
    };
    default_1.prototype.renderMiss = function () {
        return this.props.miss || [];
    };
    default_1.prototype.renderContent = function () {
        return this.props.children;
    };
    default_1.prototype.render = function () {
        if (!__loaded) {
            return [];
        }
        return __SERVICES.has(_.toLower(this.props.id)) ? this.renderContent() : this.renderMiss();
    };
    default_1.hasService = function (serviceId) {
        if (!__loaded) {
            var json = utils_1.Ajax.GETASYNC('/api-common/services');
            if (_.isArray(json.data) && json.data.length > 0) {
                __loaded = true;
                json.data.map(function (serviceId) { return __SERVICES.add(_.trim(_.toLower(serviceId))); });
            }
        }
        return __SERVICES.has(_.toLower(serviceId));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
