import * as React from 'react';
/***
 * UDescriptions 类似于 Descriptions , 显示更友好，
 * 推荐打开方式 UInfo
*/
export type UDescriptionsProps = {
    /**
     *
    */
    className?: string;
    style?: React.CSSProperties;
    children?: React.ReactNode;
    title?: React.ReactNode;
    column?: number;
    width?: number;
    /**
     * 说明： leblel width 目前支持1-20，请传字数（汉字）
    */
    lebelWidth: number;
};
export type UDescriptionsItemProps = {
    className?: string;
    label?: React.ReactNode;
    span?: number;
    breakLebel?: boolean;
    children: React.ReactNode;
};
export type ColProps = UDescriptionsItemProps & {
    isLabel: boolean;
    cols: number;
};
