"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UInfoModal = void 0;
var React = require("react");
var antd_1 = require("antd");
var UInfo_1 = require("./UInfo");
var _Util_1 = require("./_Util");
/**
 * 新版本表单弹框，支持各种类型的表单元素填写，当提交时，
 * 会调用 onOk 方法将编辑的对象信息以参数传递回去。
*/
var UInfoModal = /** @class */ (function (_super) {
    __extends(UInfoModal, _super);
    function UInfoModal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UInfoModal.prototype.render = function () {
        var _this = this;
        var layout = (0, _Util_1.getFormLayout)(this.props);
        var clazz = ['uinfo-modal'];
        if (this.props.className) {
            clazz.push(this.props.className);
        }
        return React.createElement(antd_1.Modal, __assign({ width: layout.width, destroyOnClose: true, footer: null }, this.props, { onOk: function () { return _this.props.onCancel(null); }, className: clazz.join(' ') }),
            !!this.props.content && this.props.content,
            React.createElement(UInfo_1.UInfo, __assign({}, this.props, { className: this.props.infoClassName ? this.props.infoClassName : '' })));
    };
    return UInfoModal;
}(React.PureComponent));
exports.UInfoModal = UInfoModal;
