/// <reference types="react" />
import { STreeOpts } from './interface';
import { BaseTree, BaseTreeState } from './BaseTree';
/**
 * 静态树
 * CRUD        ：  不支持
 * 动态加载     ：  不支持
 * 搜索         ：  支持
 * 数据         ： 需要组装好后传入
 *
*/
export declare class STree extends BaseTree<STreeOpts, BaseTreeState> {
    componentDidUpdate(prevProps: any): void;
    componentDidMount(): void;
    render(): any[] | JSX.Element;
}
