import * as React from 'react';
import { VFormProps, Column } from './interface';
/**
 * Form表单
 */
declare class FromContent extends React.PureComponent<VFormProps> {
    addFormItemIds: any;
    state: any;
    renderValuMap: Map<any, any>;
    componentDidMount(): void;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
    changeItemWitdh: () => void;
    getInitialValue: (column: Column, isOrgin?: boolean) => any;
    setInitialValue: () => void;
    getInitTailValue(): void;
    getRules: (column: Column) => any[];
    setInitLinkValue: () => void;
    changeLink: (column: Column, val: any) => void;
    changeTail: (e: any, field: any) => void;
    inputElement: (column: Column) => JSX.Element;
    setItemStyle: (column: Column, span: any, gutter: number, tail?: boolean) => {
        width: string;
        paddingRight: string;
    };
    add: (field: any) => void;
    remove: (k: any) => void;
    formItems(column: any): any;
    addItemColumn(column: Column): JSX.Element;
    buildColumn: (column: Column) => JSX.Element | JSX.Element[];
    buildGroups: () => JSX.Element;
    buildFooter: () => JSX.Element;
    setValues: (values: any) => any;
    onSubmit: (e: any) => Promise<any>;
    onCancle: (e: any) => void;
    onModalOk: (v: any) => void;
    onModalCancel: () => void;
    render(): JSX.Element;
}
declare const VForm: import("antd/lib/form/interface").ConnectedComponentClass<typeof FromContent, import("antd/lib/_util/type").Omit<VFormProps, "form">>;
export default VForm;
