import * as React from 'react';
interface TransfileUploadProps {
    /**
     * 初始文件值
     */
    initialValue?: any;
    /**
     * 文件上传后移动的API
     */
    fileTransfer?: any;
    /**
     * 文件上传参数
     */
    param?: {
        describe?: string;
        filePath?: string;
    };
    /**
     * 上传按钮
     */
    btn?: React.ReactNode;
    /**
     * 上传回调函数，参数是调用fileTransfer接口的返回值，文件已存在的话就直接返回
     */
    onUp?: (data: any) => void;
    [propName: string]: any;
}
export default class TransfileUpload extends React.PureComponent<TransfileUploadProps> {
    state: {
        upLoading: boolean;
        upLoadName: string;
    };
    componentDidMount(): void;
    setId: (data: any) => Promise<any>;
    render(): JSX.Element;
}
export {};
