/**
 * 虚拟滚动条
 * @author 涂美政
 */
import * as React from 'react';
import ScrollProps from './interface';
export default class extends React.PureComponent<ScrollProps> {
    state: {
        showVeriticalTrack: boolean;
        showHorizontalTrack: boolean;
        barProps: {
            top: number;
            left: number;
            bottom: number;
            right: number;
        };
        trackColor: string;
        hideBar: boolean;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    handleReadyStateChange: () => void;
    prepareScrollbar: () => void;
    collectInfo: () => void;
    updateTrackVisible: () => void;
    handleContainerScroll: () => void;
    handleMouseOver: () => void;
    handleMouseOut: () => void;
    handleVerticalHandleMouseDown: (d: any, e: any) => void;
    handleHandleMouseMove: (e: any) => void;
    handleHandleMouseUp: () => void;
    el: any;
    offsetHeight: number;
    offsetWidth: number;
    lastScrollHeight: number;
    lastScrollWidth: number;
    activeHandle: any;
    lastMousePos: any;
    lastContainerScrollTop: number;
    lastContainerScrollLeft: number;
    handleHider: any;
    render(): JSX.Element;
}
