"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
antd_1.Popconfirm.defaultProps.placement = 'topRight';
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderOverlay = function (prefixCls) {
            var _a = _this.props, okButtonProps = _a.okButtonProps, cancelButtonProps = _a.cancelButtonProps, title = _a.title, cancelText = _a.cancelText, okText = _a.okText, okType = _a.okType, icon = _a.icon;
            return React.createElement("div", null,
                React.createElement("div", { className: "".concat(prefixCls, "-inner-content") },
                    React.createElement("div", { className: "".concat(prefixCls, "-message") },
                        icon,
                        React.createElement("div", { className: "".concat(prefixCls, "-message-title") }, title)),
                    React.createElement("div", { className: "".concat(prefixCls, "-buttons") },
                        React.createElement(antd_1.Button, __assign({ onClick: _this.onConfirm, type: okType, size: "small" }, okButtonProps), okText || '确定'),
                        React.createElement(antd_1.Button, __assign({ onClick: _this.onCancel, size: "small" }, cancelButtonProps), cancelText || '取消'))));
        };
        return _this;
    }
    return default_1;
}(antd_1.Popconfirm));
exports.default = default_1;
