"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VButton = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var dva_1 = require("dva");
var VAPButton = /** @class */ (function (_super) {
    __extends(VAPButton, _super);
    function VAPButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VAPButton.prototype.render = function () {
        var e_1, _a;
        if (_.has(this.props, 'loading_effect')) {
            // @ts-ignore;
            var _loadingEffect = this.props._loading.effects;
            if (_.isArray(this.props.loading_effect)) {
                try {
                    for (var _b = __values(this.props.loading_effect), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var loadingeffect = _c.value;
                        if (_loadingEffect[loadingeffect]) {
                            return React.createElement(antd_1.Button, __assign({}, this.props, { disabled: true, loading: true }));
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            else if (_loadingEffect[this.props.loading_effect]) {
                return React.createElement(antd_1.Button, __assign({}, this.props, { disabled: true, loading: true }));
            }
        }
        return React.createElement(antd_1.Button, __assign({}, this.props));
    };
    return VAPButton;
}(React.PureComponent));
exports.VButton = (0, dva_1.connect)(function (_a) {
    var _loading = _a._loading;
    return ({ _loading: _loading });
})(VAPButton);
