import { ChartOpts } from '../interface';
/**
 * 普通雷达图的参数
*/
export interface RadarOpts extends ChartOpts {
    /**
     * 数组，取值的field
    */
    labelFields: string[];
    /**
     * 数组，Label文案
    */
    labelTexts: string[];
    /**
     * 最大值
    */
    maxValue: number;
    /**
     * 环圈数量
    */
    levels?: number;
}
export declare function createNodes(numNodes: any, radius: any): any[];
