"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            show: false
        };
        _this.hide = function () {
            _this.setState({ show: false });
        };
        return _this;
    }
    default_1.prototype.toogle = function (show) {
        if (show) {
            this.setState({ show: show });
        }
    };
    default_1.prototype.overlay = function () {
        return React.createElement(antd_1.Card, null, this.props.children);
    };
    default_1.prototype.render = function () {
        var _this = this;
        return React.createElement(antd_1.Dropdown, { overlay: this.overlay(), placement: "bottomLeft", onVisibleChange: function (show) { return _this.toogle(show); }, visible: this.state.show, trigger: ['click'] }, this.props.action);
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
