import { DragactLayoutItem, mapLayout } from "../dragact-type";
import { GridItemEvent } from "../gridItem";
/**
 * 压缩单个元素，使得每一个元素都会紧挨着边界或者相邻的元素
 * @param {*} finishedLayout 压缩完的元素会放进这里来，用来对比之后的每一个元素是否需要压缩
 * @param {*} item
 */
export declare const compactItem: (finishedLayout: DragactLayoutItem[], item: DragactLayoutItem) => DragactLayoutItem;
/**
 * 压缩layout，使得每一个元素都会紧挨着边界或者相邻的元素
 * @param {*} layout
 */
export declare const compactLayout: (layout: DragactLayoutItem[], movingItem: GridItemEvent | undefined, mapedLayout: mapLayout) => {
    compacted: any[];
    mapLayout: mapLayout;
};
