"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var echarts = require("echarts");
var id = 1000;
var genId = function () {
    id++;
    return '__echart__' + id;
};
/**
 * 定义 echart 的规范
*/
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.id = genId();
        _this.chart = null;
        return _this;
    }
    default_1.prototype.componentDidMount = function () {
        this.chart = echarts.init(document.getElementById(this.id));
        this.build();
    };
    default_1.prototype.componentDidUpdate = function () {
        this.update();
    };
    default_1.prototype.render = function () {
        var param = {
            className: 'comment-echart',
            style: {}
        };
        if (this.props.className) {
            param.className = param.className + ' ' + this.props.className;
        }
        _.extend(param.style, this.props.style, {
            width: this.props.width || '100%',
            height: this.props.height || '100%',
        });
        return React.createElement("div", __assign({ id: this.id }, param));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
