declare class Manager {
    ALL_GROUPS: string[][];
    constructor(all_groups: string[][]);
    getServiceIdByUrl(pathname: any): string;
    getModelsByServiceId(service_id: any): any[];
}
export default class VapRegister {
    private service_id;
    private pathname;
    static getManager(all_groups: any): Manager;
    constructor(service_id: string);
    private toArray;
    models(...models: any[]): void;
    views(...components: {
        path: string;
        component: any;
        like?: boolean;
    }[]): void;
    nodes(...nodes: any[]): void;
    lazyLoad(resolveView: () => Promise<any>, resolveModels?: () => ((Promise<any>)[] | Promise<any>)): typeof React.Component;
}
import * as React from 'react';
export {};
