"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var utils_1 = require("../../utils");
var DOMAIN_URL = '/api-common/secruity/domain/tree';
utils_1.Ajax.SESION(DOMAIN_URL);
// 安全域多选选择器
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            show: false,
            currentNode: null,
            domainTree: [],
            selectedKeys: [],
            selectedEvt: { domainNameList: [], domainCodeList: [] },
            defaultExpandedKeys: []
        };
        //生成树
        _this.renderTree = function (data) {
            var _data = [];
            if (_.isObject(data) || _.isArray(data)) {
                _data = _.concat([], data);
            }
            else {
                return;
            }
            return _data.map(function (item) {
                if (item.children && item.children.length > 0) {
                    return React.createElement(antd_1.Tree.TreeNode, { disabled: item.isAuthorized == 0, title: item.domainName, key: item.code, selectable: item.isAuthorized == 1, dataRef: item }, _this.renderTree(item.children));
                }
                return React.createElement(antd_1.Tree.TreeNode, { disabled: item.isAuthorized == 0, title: item.domainName, key: item.code, selectable: item.isAuthorized == 1, dataRef: item });
            });
        };
        //选中树
        _this.selectTree = function (selectedKeys, evt) {
            var _a = _this.state.selectedEvt, domainNameList = _a.domainNameList, domainCodeList = _a.domainCodeList;
            if (evt.selected) {
                domainNameList = _.concat([], domainNameList, evt.node.props.dataRef.domainName);
                domainCodeList = _.concat([], domainCodeList, evt.node.props.dataRef.code);
            }
            else {
                domainNameList = _.filter(domainNameList, function (d) { return d != evt.node.props.dataRef.domainName; });
                domainCodeList = _.filter(domainCodeList, function (d) { return d != evt.node.props.dataRef.code; });
            }
            _this.setState({ selectedKeys: selectedKeys, selectedEvt: { domainNameList: domainNameList, domainCodeList: domainCodeList } });
        };
        //清除已选
        _this.clear = function () {
            _this.setState({ selectedKeys: [], selectedEvt: { domainNameList: [], domainCodeList: [] } });
        };
        return _this;
    }
    default_1.prototype.componentWillMount = function () {
        this.getTree();
    };
    default_1.prototype.componentDidMount = function () {
        if (this.props.domainInfo) {
            var _a = __read([[], []], 2), selectedKeys = _a[0], domainNameList = _a[1];
            if (this.props.domainInfo.domainCode) {
                selectedKeys = this.props.domainInfo.domainCode.split(',');
            }
            if (this.props.domainInfo.domainName) {
                domainNameList = this.props.domainInfo.domainName.split(',');
            }
            this.setState({ selectedKeys: selectedKeys, selectedEvt: { domainNameList: domainNameList, domainCodeList: selectedKeys } });
        }
    };
    //同步获取全部Domain
    default_1.prototype.getTree = function () {
        return __awaiter(this, void 0, void 0, function () {
            var domainTree;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        domainTree = utils_1.Cache.sessionData(DOMAIN_URL);
                        if (!!domainTree) return [3 /*break*/, 2];
                        return [4 /*yield*/, utils_1.Ajax.GETASYNC(DOMAIN_URL)];
                    case 1:
                        domainTree = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (_.isObject(domainTree)) {
                            utils_1.Cache.sessionData(DOMAIN_URL, domainTree);
                            this.setState({ domainTree: domainTree, defaultExpandedKeys: _.concat([], domainTree['code']) });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    //提交树
    default_1.prototype.onChooseNode = function (selectedEvt) {
        this.setState({ show: false });
        this.props.onSelect({
            domainCode: selectedEvt.domainCodeList.join(','),
            domainName: selectedEvt.domainNameList.join(','),
        });
    };
    default_1.prototype.show = function () {
        this.setState({ show: true });
    };
    default_1.prototype.render = function () {
        var _this = this;
        return React.createElement(antd_1.Modal, { destroyOnClose: true, visible: this.state.show, title: '请选择安全域', bodyStyle: { maxHeight: 560, overflow: 'auto' }, footer: React.createElement("div", null,
                this.state.selectedKeys.length > 0 && React.createElement("a", { onClick: this.clear, style: { marginRight: 10 } }, "(\u5DF2\u9009".concat(this.state.selectedKeys.length, "\u4E2A) \u6E05\u9664\u5DF2\u9009")),
                React.createElement(antd_1.Button, { disabled: this.props.required && this.state.currentNode == null, type: "primary", onClick: function () { return _this.onChooseNode(_this.state.selectedEvt); } }, "\u786E\u5B9A")), onCancel: function () { return _this.setState({ show: false }); } },
            React.createElement(antd_1.Tree, { multiple: true, onSelect: this.selectTree, showLine: true, selectedKeys: this.state.selectedKeys, defaultExpandedKeys: this.state.defaultExpandedKeys }, this.renderTree(this.state.domainTree)));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
