"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrefixInput = void 0;
var React = require("react");
var antd_1 = require("antd");
var PrefixInput = /** @class */ (function (_super) {
    __extends(PrefixInput, _super);
    function PrefixInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            select: '',
            input: '',
        };
        return _this;
    }
    PrefixInput.prototype.componentDidMount = function () {
        this.setState({
            select: this.props.value[0],
            input: this.props.value[1],
        });
    };
    PrefixInput.prototype.render = function () {
        var _this = this;
        var _a = this.state, select = _a.select, input = _a.input;
        return React.createElement(antd_1.Input, { addonBefore: React.createElement(antd_1.Select, { placeholder: "\u8BF7\u9009\u62E9", onChange: function (val) {
                    _this.setState({ select: val }, function () { return _this.props.onChange([_this.state.select, _this.state.input]); });
                }, value: select, style: { width: 100 } }, this.props.options.map(function (item) { return React.createElement(antd_1.Select.Option, { value: item.value }, item.name); })), placeholder: this.props.placeholder, onChange: function (evt) { return _this.setState({ input: evt.target.value }, function () { return _this.props.onChange([_this.state.select, _this.state.input]); }); }, value: input, autoComplete: "off" });
    };
    return PrefixInput;
}(React.PureComponent));
exports.PrefixInput = PrefixInput;
