/// <reference types="react" />
import { Column, Link } from './interface';
export default class {
    trigger: Map<string, Link>;
    stroge: Map<string, any[]>;
    columns: Column[];
    constructor(columns: Column[]);
    init(data: any): void;
    getOptions(column: Column): {
        name: React.ReactNode;
        value: string | number;
    }[];
    call(column: Column, value: any, callBack?: Function): void;
}
