"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListSelect = void 0;
var antd_1 = require("antd");
var React = require("react");
var _ = require("lodash");
var utils_1 = require("../../utils");
var SearchBar_1 = require("../Table/SearchBar");
var UPagination_1 = require("../UPagination");
/**
 * 列表弹框，弹出一个列表。
 * 1. 可以对列表里面的数据进行增删改查
 * 2. 可以弹出一个单选或多选框，选一条或多条数据后，返回给页面
*/
var ListSelect = /** @class */ (function (_super) {
    __extends(ListSelect, _super);
    function ListSelect() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            loading: true,
            list: [],
            current: 1,
            total: 0,
            selectedRowKeys: [],
            selectedRowObjects: [],
            isList: true,
        };
        _this.valueField = 'id';
        _this.labelField = 'id';
        _this.columns = [];
        _this.selected = [];
        _this.pageKeys = [];
        _this.sorter = {};
        _this.param = {};
        // 过滤
        _this.query = function (param) {
            var SIZE_DEFAULT = window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT;
            _this.param = _.assign({}, _this.props.param, { start_: 0, count_: SIZE_DEFAULT }, param);
            _.keys(param).map(function (key) {
                if (_.endsWith(key, '-label')) {
                    _.unset(param, key);
                }
            });
            _this.setState({ loading: true });
            utils_1.Ajax.POST(_this.props.api, _this.param, function (json) {
                _this.setState({ loading: false, list: _.has(json, "list") ? json.list : json.data, total: json.total, current: 1 });
            });
        };
        return _this;
    }
    //删除的传参
    ListSelect.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, VLIST, VDATA, SIZE_DEFAULT, resp, isList, selectedRowKeys, selectedRowKeys;
            var _b;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = window.VAP_GLOBAL, VLIST = _a.VLIST, VDATA = _a.VDATA, SIZE_DEFAULT = _a.PAGINATION.SIZE_DEFAULT;
                        this.valueField = this.props.valueField || this.valueField;
                        this.labelField = this.props.labelField ? this.props.labelField : this.valueField;
                        if (this.props.selected) {
                            this.selected = _.concat([], this.props.selected);
                        }
                        if (this.props.canSelect) {
                            this.columns = _.concat([], this.props.columns, [
                                { title: '操作', className: 'table-actions', render: function (i, obj) { return React.createElement(antd_1.Button, { disabled: _this.props.canSelect(obj), size: "small", onClick: function () { return _this.onOk([obj[_this.valueField]], [obj]); } }, "\u9009\u62E9"); } }
                            ]);
                        }
                        else {
                            this.columns = _.concat([], this.props.columns, [
                                { title: '操作', className: 'table-actions', render: function (i, obj) { return React.createElement(antd_1.Button, { size: "small", onClick: function () { return _this.onOk([obj[_this.valueField]], [obj]); } }, "\u9009\u62E9"); } }
                            ]);
                        }
                        this.param = _.assign({}, (_b = {}, _b[VLIST.start] = 0, _b[VLIST.count] = SIZE_DEFAULT, _b), this.props.param);
                        if (this.props.beforeQuery) {
                            this.param = this.props.beforeQuery(this.param);
                            if (this.param === false) {
                                return [2 /*return*/];
                            }
                        }
                        return [4 /*yield*/, utils_1.Ajax.POST(this.props.api, this.param)];
                    case 1:
                        resp = _c.sent();
                        isList = _.has(resp, VLIST.list);
                        if (isList) {
                            this.pageKeys = resp[VLIST.list].map(function (item) { return "".concat(item[_this.valueField]); });
                            selectedRowKeys = _.intersection(this.pageKeys, this.selected);
                            this.setState({ loading: false, isList: isList, list: resp[VLIST.list], total: resp[VLIST.total], current: 1, selectedRowKeys: selectedRowKeys });
                        }
                        else {
                            selectedRowKeys = _.intersection(this.pageKeys, this.selected);
                            this.setState({ loading: false, isList: isList, list: resp[VDATA.data], selectedRowKeys: selectedRowKeys });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ListSelect.prototype.onSelect = function (selectedRowKeys, selectedRowObjects) {
        var _this = this;
        // let used = _.intersection(this.pageKeys, this.selected);
        // let pulls = [];
        // 本身选中的，被取消了，则移出记录
        // let selectKeys = [];
        this.pageKeys.map(function (item) {
            if (selectedRowKeys.indexOf(item) < 0) {
                var idx = _this.selected.indexOf(item);
                if (idx >= 0) {
                    _.pullAt(_this.selected, [idx]);
                }
            }
            else {
                var idx = _this.selected.indexOf(item);
                if (idx < 0) {
                    _this.selected.push(item);
                }
            }
        });
        this.setState({ selectedRowKeys: selectedRowKeys, selectedRowObjects: selectedRowObjects });
    };
    ListSelect.prototype.onOk = function (selectedRowKeys, selectedRowObjects) {
        var _this = this;
        if (selectedRowKeys) {
            this.props.onSelect(selectedRowKeys, selectedRowObjects, selectedRowObjects[0][this.labelField]);
        }
        else {
            this.props.onSelect(_.union(_.concat([], this.selected, this.state.selectedRowKeys)), this.state.selectedRowObjects, this.state.selectedRowObjects.map(function (item) { return item[_this.labelField]; }).join(','));
        }
    };
    // 翻页与排序
    ListSelect.prototype.search = function (pagination, filters, sorter) {
        var _this = this;
        var VLIST = window.VAP_GLOBAL.VLIST;
        var _param = {};
        var current = this.state.current;
        if (pagination) {
            current = pagination.current;
            _param[VLIST.start] = (current - 1) * pagination.pageSize;
            _param[VLIST.count] = pagination.pageSize;
        }
        else if (sorter) {
            if (!_.isEqual(this.sorter, sorter)) {
                _param.start = 0;
                this.sorter = sorter;
            }
            if (_.has(sorter, 'field')) {
                _param[VLIST.order] = sorter.field;
                _param[VLIST.by] = sorter.order == 'ascend' ? 'asc' : 'desc';
            }
            else {
                _param[VLIST.order] = null;
                _param[VLIST.by] = null;
            }
        }
        _.assign(this.param, _param);
        this.setState({ loading: true });
        utils_1.Ajax.POST(this.props.api, this.param, function (json) {
            _this.setState({ loading: false, list: _.has(json, "list") ? json.list : json.data, total: json.total, current: current });
        });
    };
    ListSelect.prototype.renderSearchBar = function () {
        var _this = this;
        var searchBar = null;
        if (_.has(this.props, 'searchBar')) {
            searchBar = this.props.searchBar;
        }
        if (searchBar) {
            return React.createElement(SearchBar_1.default, __assign({}, searchBar, { onSearch: function (param) { return _this.query(param); }, default: this.props.param, param: this.param }));
        }
        return React.createElement(React.Fragment, null);
    };
    ListSelect.prototype.renderFooter = function () {
        var _this = this;
        var footer = [];
        var SIZE_DEFAULT = window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT;
        if (this.state.isList && this.state.total > SIZE_DEFAULT) {
            footer.push(React.createElement(UPagination_1.default, { onChange: function (current, pageSize) { return _this.search({ current: current, pageSize: pageSize }, null); }, current: this.state.current, total: this.state.total, showSizeChanger: false, pageSize: SIZE_DEFAULT }));
        }
        if (this.props.multi) {
            footer.push(React.createElement("div", null));
            footer.push(React.createElement(antd_1.Button, { style: { margin: '6px 12px 0 0' }, disabled: this.state.selectedRowKeys.length == 0, onClick: function () { return _this.onOk(); }, type: "primary" },
                "\u9009\u62E9",
                this.state.selectedRowKeys.length > 0 ? "(".concat(this.state.selectedRowKeys.length, ")") : ''));
        }
        if (footer.length) {
            return React.createElement(antd_1.Layout.Footer, { className: "vap-table-footer" }, footer);
        }
        return React.createElement(React.Fragment, null);
    };
    ListSelect.prototype.render = function () {
        var _this = this;
        var modalParam = {};
        modalParam.title = [];
        var tableParam = {};
        if (this.props.multi) {
            tableParam.rowSelection = {
                selectedRowKeys: this.state.selectedRowKeys,
                onChange: function (selectedRowKeys, selectedRowObjects) { return _this.onSelect(selectedRowKeys, selectedRowObjects); },
            };
            if (this.props.canSelect) {
                tableParam.rowSelection.getCheckboxProps = function (record) {
                    return {
                        disabled: _this.props.canSelect(record),
                    };
                };
            }
        }
        return React.createElement(antd_1.Layout, null,
            this.renderSearchBar(),
            React.createElement(antd_1.Layout, null,
                React.createElement(antd_1.Layout.Content, { className: "vap-table-content" },
                    React.createElement(antd_1.Table, __assign({}, tableParam, { loading: this.state.loading, rowKey: this.valueField, columns: this.columns, pagination: false, onChange: function (pagination, filters, sorter) { return _this.search(null, filters, sorter); }, dataSource: this.state.list, size: "small" }))),
                this.renderFooter()));
    };
    return ListSelect;
}(React.PureComponent));
exports.ListSelect = ListSelect;
