/// <reference types="react" />
import { BTN_CLICK, ActBTN, ActButton, ActionPorps, CustomAciton } from './interface';
export declare const INFO: ((props: ActionPorps) => JSX.Element);
export declare const EDIT: ((props: ActionPorps) => JSX.Element);
export declare const DELETE: ((props: ActionPorps) => JSX.Element);
export declare const ACTION: ((props: CustomAciton) => JSX.Element);
/**
 * 通用添加按钮
*/
export declare const BUTTON_ADD: (onClick: BTN_CLICK, props?: ActBTN) => ActButton;
/**
 * 通用删除按钮
*/
export declare const BUTTON_DELETE: (onClick: BTN_CLICK, props?: ActBTN) => ActButton;
/**
 * 通用更多按钮，需要传子菜单
*/
export declare const BUTTON_MORE: (children: ActButton[]) => ActButton;
/**
 * 通用导入按钮
*/
export declare const BUTTON_IMPORT: (onClick: BTN_CLICK, props?: ActBTN) => ActButton;
/**
 * 通用导出按钮
*/
export declare const BUTTON_EXPORT: (onClick: BTN_CLICK, props?: ActBTN) => ActButton;
