/// <reference types="react" />
import { FTreeOpts } from './interface';
import { ActionTree } from './ActionTree';
/**
 * 静态树
 * CRUD        ：  支持
 * 动态加载     ：  支持
 * 搜索         ：  支持
 * 数据         ： 通过 GET fetchApi 或 GET api  获取，响应必须为 VData<List<Object>> 结构
*/
export declare class FTree extends ActionTree<FTreeOpts> {
    componentDidMount(): Promise<void>;
    clearCache(parentId: string): void;
    getChildren(parentId: any): Promise<any[]>;
    render(): any[] | JSX.Element;
}
