import * as React from 'react';
import type { UploadChangeParam } from 'antd/lib/upload';
import type { UploadModalProps } from './interface';
/**
 * 标准导入数据弹框，用于统一系统内， 所有需要导入数据的交互。
*/
export declare class UploadModal extends React.PureComponent<UploadModalProps> {
    state: {
        showProgress: boolean;
        percent: number;
        uploading: boolean;
        importing: boolean;
        error: any;
        success: any;
    };
    _isShutDown(old: any): boolean;
    componentDidUpdate(old: any): void;
    onUpChange(info: UploadChangeParam): Promise<void>;
    renderTip(): {};
    renderMessage(): JSX.Element;
    renderUpload(): JSX.Element;
    renderFooter(): JSX.Element;
    render(): JSX.Element;
}
