"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var _ = require("lodash");
var moment = require("moment");
var VFormModal_1 = require("./VFormModal");
var _TransfileUpload_1 = require("./_TransfileUpload");
var _FileUpload_1 = require("./_FileUpload");
var SingleImage_1 = require("../Upload/SingleImage");
var _EditTable_1 = require("./_EditTable");
var _EditTag_1 = require("./_EditTag");
var _SelectModal_1 = require("./_SelectModal");
var PrefixInput_1 = require("../FormModal/PrefixInput");
var default_separator = '//';
var formatFields = function (str) { return str.toString().replace(/，/g, ',').replace(/\s/g, '').replace(/,{2,}/g, ','); };
var defaultGroupKey = [];
var modalValue = ''; //存储Modal提交的值
var formItemLayoutWithOutLabel = {
    wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 20, offset: 4 },
    },
};
//循环查找是否显示或者禁用
function hasField(field, data) {
    var e_1, _a;
    var has = false;
    try {
        for (var _b = __values(data.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var item = _c.value;
            if (item.has(field)) {
                has = true;
                break;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return has;
}
/**
 * Form表单
 */
var FromContent = /** @class */ (function (_super) {
    __extends(FromContent, _super);
    function FromContent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.addFormItemIds = {};
        _this.state = {
            column: {},
            tailValue: {},
            activeKey: [],
            disabledMap: new Map(),
            unshowMap: new Map(),
            optionMap: new Map(),
            showVForm: false,
            showSelectModal: false,
        };
        _this.renderValuMap = new Map(); //render转义前的值
        //操作dom修改label宽度
        _this.changeItemWitdh = function () {
            if (_.get(_this.props, 'layout') === 'leftText') {
                return;
            }
            var items = document.querySelectorAll('.vform-item .ant-form-item-label');
            items.forEach(function (d, key) {
                d.style.flexBasis = _this.props.labelWidth + 'px';
            });
            _this.props.columns.map(function (item, index) {
                if (item.labelWidth) {
                    items.forEach(function (d, key) {
                        if (d.innerText == item.title)
                            d.style.flexBasis = item.labelWidth + 'px';
                    });
                }
            });
        };
        //初始化值，初始化unshow和disabled
        _this.getInitialValue = function (column, isOrgin) {
            var e_2, _a;
            if (isOrgin === void 0) { isOrgin = false; }
            var defaultData = _.assign({}, _this.props.default || {}, _this.props.data || {});
            var v = defaultData[column.field];
            if (_.has(column, 'tail') && !_.get(column, 'tail.field')) {
                var tailIndex = "".concat(v).lastIndexOf(_.get(column, 'tail.separator') || default_separator);
                if (tailIndex > -1) {
                    v = "".concat(v).substr(0, tailIndex);
                }
            }
            if (column.type == 'prefix-text') {
                var ptn = column.field.split(',');
                var _b = __read([undefined, undefined], 2), select = _b[0], input = _b[1];
                if (ptn.length == 2) {
                    var _c = __read(ptn, 2), selectField = _c[0], inputField = _c[1];
                    if (_.has(_this.props.data, selectField)) {
                        select = _this.props.data[selectField] + '';
                    }
                    if (_.has(_this.props.data, inputField)) {
                        input = _this.props.data[inputField] + '';
                    }
                    ;
                }
                else {
                    input = _.has(_this.props.data, column.field) ? _this.props.data[column.field] + '' : '';
                    if (input == null || input == '') {
                        return [select, input];
                    }
                    if (!_.has(column, 'options')) {
                        return [select, input];
                    }
                    try {
                        for (var _d = __values(column.options), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var opt = _e.value;
                            var prefix = opt.value + '';
                            if (_.startsWith(input, prefix)) {
                                select = prefix;
                                input = input.substr(prefix.length);
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
                return [select, input];
            }
            if (column.type === 'checkbox' || column.type === 'select' || column.type === 'cascader' || column.type === 'icon' || column.type === 'selectGroup') {
                return (v || v === 0) ? (_.isString(v) ? v.split(',') : [v]) : [];
            }
            else if (column.type === 'multiselect') {
                if (v == null || v == '') {
                    return [];
                }
                if (column.config && column.config.labelInValue) {
                    return v.split(',').map(function (key) { return ({ key: key, label: key }); });
                }
                return v.split(',');
            }
            else if (column.type === 'switch') {
                var index = _.findIndex(column.options, function (d) { return v && d.value == v; });
                return index == 1 ? false : true;
            }
            else if (column.type === 'date') {
                return v ? moment(v) : moment();
            }
            else if (column.type === 'dateNull') {
                return v ? moment(v) : null;
            }
            else if (column.type === 'month') {
                return v ? moment(v, 'YYYY-MM') : moment();
            }
            else if (column.type === 'time') {
                return v ? moment(v, 'HH:mm:ss') : moment();
            }
            else if (column.type === 'daterange') {
                return v ? v.split(',').map(function (d) { return moment(d); }).slice(0, 2) : [moment(), moment()];
            }
            else if (column.type === 'file' || column.type === 'fileinfo' || column.type === 'transfile') {
                return _.isNil(v) ? '' : v;
            }
            else if (column.type === 'edittable' || column.type === 'tag') {
                try {
                    if (!_.isObject(v)) {
                        v = JSON.parse(v);
                    }
                }
                catch (e) { }
                v = _.isArray(v) ? _.concat([], v) : [];
                return v;
            }
            var initValue = _.isNil(v) ? '' : v;
            if (isOrgin) {
                return initValue;
            }
            var renderInitValue = initValue;
            if (_.has(column, 'render')) {
                !_this.renderValuMap.has(column.field) && _this.renderValuMap.set(column.field, initValue);
                renderInitValue = column['render'](initValue);
            }
            return renderInitValue;
        };
        //formKey不同时，强制重新设置form值
        _this.setInitialValue = function () {
            _this.props.columns.map(function (column) {
                var _a;
                var initialValue = _this.getInitialValue(column);
                _this.props.form.setFieldsValue((_a = {}, _a[column.field] = initialValue, _a));
            });
        };
        //初始化规则
        _this.getRules = function (column) {
            if (_.isArray(column.rule)) {
                return _.map(column.rule, function (rule) { return (_.has(rule, 'message') ? rule : __assign(__assign({}, rule), { message: "".concat(column.title, "\u4E3A\u5FC5\u586B\u9879") })); });
            }
            return column.rule;
        };
        //初始化设置Link
        _this.setInitLinkValue = function () {
            _this.props.columns.map(function (column) {
                var v = _this.getInitialValue(column);
                _this.changeLink(column, v);
            });
        };
        //监控link中禁用和不展示的字段变化
        _this.changeLink = function (column, val) {
            var init = null;
            if (column.render) {
                init = _this.getInitialValue(column, true);
            }
            if (_.has(column.link, 'optionsChange')) {
                var options_1 = column.link.optionsChange(val, init);
                // let data = this.props.form.getFieldsValue();
                var values_1 = {};
                // const { optionMap } = this.state;
                var optionMap_1 = new Map();
                _.keys(options_1).map(function (field) {
                    optionMap_1.set(field, options_1[field]);
                    values_1[field] = undefined;
                });
                _this.setState({ optionMap: optionMap_1 }, function () { return _this.props.form.setFieldsValue(values_1); });
            }
            if (_.has(column.link, 'unshow')) {
                var unshowFields = column.link.unshow(val, init);
                _this.setState({ unshowMap: _this.state.unshowMap.set(column.field, new Set(unshowFields)) });
                window.setTimeout(function () { return _this.props.labelWidth && _this.changeItemWitdh(); }, 5);
            }
            if (_.has(column.link, 'disabled')) {
                var disabledFields = column.link.disabled(val, init);
                _this.setState({ disabledMap: _this.state.disabledMap.set(column.field, new Set(disabledFields)) });
            }
            if (_.has(column.link, 'valuesChange')) {
                var fieldValues_1 = column.link.valuesChange(val, init);
                fieldValues_1 && window.setTimeout(function () { return _this.props.form.setFieldsValue(fieldValues_1); }, 10);
            }
        };
        //监控tail变化
        _this.changeTail = function (e, field) {
            e.persist();
            _this.setState(function (state) {
                var _a;
                return { tailValue: __assign(__assign({}, state.tailValue), (_a = {}, _a[field] = e.target.value, _a)) };
            });
        };
        //构建组件
        _this.inputElement = function (column) {
            var disabled = ((_.has(column, 'disabled') && column.disabled !== false) || hasField(column.field, _this.state.disabledMap)) ? true : false;
            var options = _this.state.optionMap.has(column.field) ? _this.state.optionMap.get(column.field) : column.options;
            var hasOnChange = _.get(column, 'config.onChange');
            var commonParam = __assign(__assign({ style: { width: '100%' }, autoComplete: 'off' }, _.extend({}, column.config || {})), { title: _.has(column.config, 'title') ? column.config.title(_this.props.form.getFieldValue(column.field)) : _this.props.form.getFieldValue(column.field), placeholder: column.placeholder === false ? undefined : (column.placeholder || "\u8BF7".concat(_.includes(['modal', 'selectmodal', 'vformmodal', 'date', 'dateNull', 'time', 'daterange', 'month', 'cascader', 'icon', 'select', 'multiselect', 'selectGroup'], column.type) ? '选择' : '输入').concat(_this.props.labelExpand && _this.props.labelExpand[column.field] ? _this.props.labelExpand[column.field] : column.title)), disabled: disabled, onChange: _.has(column, 'link') ? function (e) { _this.changeLink(column, e.target.value); hasOnChange && hasOnChange(e); } : (hasOnChange || null), className: "vform-item-".concat(column.type) });
            var onValueChange = _.has(column, 'link') ? function (v) { _this.changeLink(column, v); hasOnChange && hasOnChange(v); } : (hasOnChange || null);
            switch (column.type) {
                case 'text':
                    return React.createElement(antd_1.Input, __assign({}, commonParam));
                case 'prefix-text':
                    return React.createElement(PrefixInput_1.PrefixInput
                    //@ts-ignore
                    , { 
                        //@ts-ignore
                        placeholder: column.placeholder ? column.placeholder : ('请填写' + column.title), value: _this.props.form.getFieldValue(column.field), options: column.options, onChange: function (val) {
                            var _a;
                            return _this.props.form.setFieldsValue((_a = {}, _a[column.field] = val, _a));
                        } });
                case 'password':
                    return React.createElement(antd_1.Input.Password, __assign({}, commonParam));
                case 'onlytext':
                    return React.createElement(antd_1.Input, __assign({}, commonParam, { readOnly: true }));
                case 'number':
                    return React.createElement(antd_1.InputNumber, __assign({}, commonParam, { onChange: onValueChange }));
                case 'textarea':
                    return React.createElement(antd_1.Input.TextArea, __assign({}, commonParam));
                case 'select':
                    if (options) {
                        return React.createElement(antd_1.Select, __assign({}, commonParam, { dropdownMatchSelectWidth: true, onChange: onValueChange }), options.map(function (opt) { return React.createElement(antd_1.Select.Option, { value: opt.value }, opt.name); }));
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'selectGroup':
                    if (options) {
                        return React.createElement(antd_1.Select, __assign({}, commonParam, { dropdownMatchSelectWidth: true, onChange: onValueChange }), options.map(function (option) {
                            if (!option.parent) {
                                return React.createElement(antd_1.Select.OptGroup, { label: option.name }, options.map(function (item) {
                                    if (item.parent == option.value) {
                                        return React.createElement(antd_1.Select.Option, { value: item.value }, item.name);
                                    }
                                }));
                            }
                        }));
                        return React.createElement(antd_1.Select, __assign({}, commonParam, { dropdownMatchSelectWidth: true, onChange: onValueChange }), options.map(function (opt) { return React.createElement(antd_1.Select.Option, { value: opt.value }, opt.name); }));
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'multiselect':
                    if (options) {
                        return React.createElement(antd_1.Select, __assign({}, commonParam, { dropdownMatchSelectWidth: true, mode: "multiple", onChange: onValueChange }), options.map(function (opt) { return React.createElement(antd_1.Select.Option, { label: opt, value: opt.value }, opt.name); }));
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'radio':
                    if (options) {
                        return React.createElement(antd_1.Radio.Group, __assign({}, commonParam),
                            options.map(function (opt) { return _.get(column, 'config.type') == 'button' ? React.createElement(antd_1.Radio.Button, { value: opt.value }, opt.name) : React.createElement(antd_1.Radio, { value: opt.value }, opt.name); }),
                            " ");
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'checkbox':
                    if (options) {
                        return React.createElement(antd_1.Checkbox.Group, __assign({}, commonParam, { onChange: onValueChange }),
                            options.map(function (opt) { return React.createElement(antd_1.Checkbox, { value: opt.value }, opt.name); }),
                            " ");
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'switch':
                    if (options) {
                        return React.createElement(antd_1.Switch, { checkedChildren: options[0].name, unCheckedChildren: options[1].name, onChange: onValueChange });
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'date':
                    return React.createElement(antd_1.DatePicker, __assign({}, commonParam, { onChange: onValueChange }));
                case 'dateNull':
                    return React.createElement(antd_1.DatePicker, __assign({}, commonParam, { onChange: onValueChange }));
                case 'month':
                    return React.createElement(antd_1.DatePicker.MonthPicker, __assign({ showTime: false, showToday: false, format: "YYYY-MM" }, commonParam, { onChange: onValueChange }));
                case 'time':
                    return React.createElement(antd_1.TimePicker, __assign({}, commonParam, { onChange: onValueChange }));
                case 'daterange':
                    return React.createElement(antd_1.DatePicker.RangePicker, __assign({}, commonParam, { onChange: onValueChange }));
                case 'cascader':
                    if (options) {
                        return React.createElement(antd_1.Cascader, __assign({ options: options, fieldNames: { label: 'name', value: 'value', children: 'children' }, changeOnSelect: true }, commonParam, { onChange: onValueChange }));
                    }
                    else {
                        console.error("".concat(column.title, "\u7684").concat(column.type, "\u5C5E\u6027\u7F3A\u5C11options\u5C5E\u6027"));
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                case 'icon':
                    return React.createElement(antd_1.Select, { onChange: onValueChange }, window['IconList'].map(function (type) { return React.createElement(antd_1.Select.Option, { className: 'vap-vform-select-icon', value: type },
                        React.createElement(antd_1.Icon, { type: type })); }));
                case 'file':
                    return React.createElement(_FileUpload_1.default, __assign({ initUrl: _this.getInitialValue(column), callback: function (v) {
                            var _a;
                            return _this.props.form.setFieldsValue((_a = {}, _a[column.field] = v, _a));
                        } }, commonParam));
                case 'fileinfo':
                    return React.createElement(_FileUpload_1.default, __assign({ initUrl: _this.getInitialValue(column), callback: function (v, info) {
                            var _a;
                            return _this.props.form.setFieldsValue((_a = {}, _a[column.field] = _.isEmpty(info) ? undefined : info, _a));
                        }, templateDownload: column.templateDownload }, commonParam));
                case 'transfile':
                    return React.createElement(_TransfileUpload_1.default, __assign({ btn: _.get(column, 'uploadButton'), onUp: function (v) {
                            var _a;
                            return _this.props.form.setFieldsValue((_a = {}, _a[column.field] = v, _a));
                        }, initialValue: _this.getInitialValue(column) }, commonParam));
                case 'image':
                    return React.createElement(SingleImage_1.default, __assign({}, column.config, { namespace: "app-portal" }, column.config, { def: _this.getInitialValue(column), callback: function (val) {
                            var _a;
                            return _this.props.form.setFieldsValue((_a = {}, _a[column.field] = val, _a));
                        } }));
                case 'modal':
                    var onModalClick = _.get(column, 'config.onClick');
                    var buttonText = _.get(column, 'config.buttonText');
                    return React.createElement(antd_1.Button, __assign({ onClick: onModalClick }, commonParam), (column.render ? column.render(_this.props.form.getFieldValue(column.field)) : _this.props.form.getFieldValue(column.field)) || _this.getInitialValue(column) || buttonText || '点击');
                case 'selectmodal':
                    if (!_.get(column, 'subConfig.selectModalProps')) {
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                    return React.createElement(antd_1.Input, __assign({ onClick: function () { return _this.setState({ column: column, showSelectModal: true }); } }, commonParam, { readOnly: true, addonAfter: React.createElement(antd_1.Icon, { type: 'select', onClick: function () { return _this.setState({ column: column, showSelectModal: true }); } }) }));
                case 'vformmodal':
                    return React.createElement(antd_1.Input, __assign({ onClick: function () { return _this.setState({ column: column, showVForm: true }); } }, commonParam, { readOnly: true }));
                case 'edittable':
                    if (!_.has(column, 'subConfig.editTableProps')) {
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                    var _a = _.get(column, 'subConfig.editTableProps'), columns = _a.columns, rowKey = _a.rowKey, onChange_1 = _a.onChange, rest = __rest(_a, ["columns", "rowKey", "onChange"]);
                    return React.createElement(_EditTable_1.default, __assign({}, rest, { disabled: disabled, dataSource: _this.props.form.getFieldValue(column.field) || _this.getInitialValue(column), columns: columns, rowKey: rowKey, onChange: function (data, param) {
                            var _a;
                            _this.props.form.setFieldsValue((_a = {}, _a[column.field] = data, _a));
                            onChange_1 && onChange_1(param);
                            _.has(_this.state.column, 'link') && _this.changeLink(_this.state.column, data);
                        } }));
                case 'tag':
                    if (!_.has(column, 'subConfig.tagProps')) {
                        return React.createElement(antd_1.Input, __assign({}, commonParam));
                    }
                    var onDeleteClick_1 = _.get(column, 'subConfig.tagProps.onDeleteClick');
                    return React.createElement(_EditTag_1.default, __assign({}, _.extend({}, _.get(column, 'subConfig.tagProps') || {}), { disabled: disabled, data: _this.props.form.getFieldValue(column.field) || _this.getInitialValue(column), onDeleteClick: function (item, i, data) {
                            var _a;
                            var newData = _.concat([], data);
                            newData.splice(i, 1);
                            _this.props.form.setFieldsValue((_a = {}, _a[column.field] = newData, _a));
                            onDeleteClick_1 && onDeleteClick_1(newData, item);
                            _.has(_this.state.column, 'link') && _this.changeLink(_this.state.column, data);
                        } }));
                default:
                    return React.createElement(antd_1.Input, __assign({}, commonParam));
            }
        };
        //单个表单样式
        _this.setItemStyle = function (column, span, gutter, tail) {
            span = _.get(column, 'span') || span;
            var allSpan = _.isNumber(span) ? (span > 0 ? span : 1) : 1;
            var tailSpan = tail ? allSpan * 2 : allSpan;
            var itemStyle = { width: "".concat(100 / tailSpan, "%"), paddingRight: "".concat(gutter, "px") };
            if (_.isObject(span)) {
                _.keys(_this.props.span).map(function (d) {
                    var spanList = formatFields(_this.props.span[d]).split(',').map(function (d) { return d.trim(); });
                    if (d && parseInt(d) && _.includes(spanList, column.field)) {
                        var tailSpan_1 = (_.has(column, 'tail') && _.get(column, 'tail.tailType') == 'formitem') ? parseInt(d) * 2 : parseInt(d);
                        itemStyle = { width: "".concat(100 / tailSpan_1, "%"), paddingRight: "".concat(gutter, "px") };
                    }
                });
            }
            return itemStyle;
        };
        _this.add = function (field) {
            if (!_.has(_this.addFormItemIds, field)) {
                _this.addFormItemIds[field] = [];
            }
            _this.addFormItemIds[field].push(_this.addFormItemIds[field].length - 1 >= 0 ? _this.addFormItemIds[field][_this.addFormItemIds[field].length - 1] + 1 : 0);
        };
        _this.remove = function (k) {
            var form = _this.props.form;
            // can use data-binding to get
            var keys = form.getFieldValue('keys');
            // We need at least one passenger
            if (keys.length === 1) {
                return;
            }
            // can use data-binding to set
            form.setFieldsValue({
                keys: keys.filter(function (key) { return key !== k; }),
            });
        };
        //构建单个表单项
        _this.buildColumn = function (column) {
            var unshow = (column.show === false || hasField(column.field, _this.state.unshowMap)) ? true : false;
            if (unshow) {
                return;
            }
            var disabled = ((_.has(column, 'disabled') && column.disabled !== false) || hasField(column.field, _this.state.disabledMap)) ? true : false;
            var getFieldDecorator = _this.props.form.getFieldDecorator;
            var initialValue = _this.getInitialValue(column);
            var rules = _this.getRules(column);
            var valuePropName = column.type == 'switch' ? 'checked' : 'value';
            var tailField = _.get(column, 'tail.field') || column.field;
            var itemStyle = _this.setItemStyle(column, _this.props.span || 1, _this.props.gutter || 12);
            var labelTemp = column.title;
            if (_this.props.labelExpand && _this.props.labelExpand[column.field]) {
                labelTemp = _this.props.labelExpand[column.field];
            }
            var formItemLabel = column.tip ? React.createElement("span", null,
                labelTemp,
                "\u00A0",
                React.createElement(antd_1.Popover, { content: _.get(column, 'tip.text') || column.tip },
                    React.createElement(antd_1.Icon, { type: _.get(column, 'tip.icon') || 'question-circle' }))) : labelTemp;
            var formItemClass = ' vform-item ' + (_this.props.titleDeep ? ' title-deep ' : '') + (column.type === 'edittable' ? ' vform-item-edittable ' : '') + (_.get(column, 'config.className') || '');
            var tailPlaceholder = (_.isString(column.tail) && column.tail) || (_.isObject(column.tail) && column.tail.placeholder) || '';
            //有尾部扩展时
            if (_.has(column, 'tail')) {
                var tailType = _.get(column, 'tail.type');
                if (tailType && tailType !== 'formitem') {
                    var formValue = _this.props.form.getFieldValue(column.field);
                    var inputWidth = _.get(column, 'tail.expandWidth');
                    var tailStyle = (_.isArray(tailType) && !_.includes(tailType, formValue)) ? { display: 'none' } : (_.isNumber(inputWidth) ? { width: inputWidth, marginLeft: _this.props.gutter || 12 } : { marginLeft: _this.props.gutter || 12 });
                    var radioClass = column.type == 'radio' ? 'vform-item-tailexpand-radio' : '';
                    return React.createElement(antd_1.Form.Item, { style: itemStyle, label: formItemLabel, className: formItemClass + ' vform-item-tailexpand ' + radioClass },
                        getFieldDecorator(column.field, { initialValue: initialValue, rules: rules, valuePropName: valuePropName })(_this.inputElement(column)),
                        React.createElement(antd_1.Input, { style: tailStyle, disabled: disabled, placeholder: tailPlaceholder, value: _this.state.tailValue[tailField], onChange: function (e) { return _this.changeTail(e, tailField); } }));
                }
                else {
                    itemStyle = _this.setItemStyle(column, _this.props.span || 1, _this.props.gutter || 12, true);
                    return [
                        React.createElement(antd_1.Form.Item, { style: itemStyle, label: formItemLabel, className: formItemClass }, getFieldDecorator(column.field, { initialValue: initialValue, rules: rules, valuePropName: valuePropName })(_this.inputElement(column))),
                        React.createElement(antd_1.Form.Item, { style: itemStyle, label: '\u9690\u85CF\u540D\u79F0', className: formItemClass + ' vform-item-tail ' },
                            React.createElement(antd_1.Input, { disabled: disabled, placeholder: tailPlaceholder, value: _this.state.tailValue[tailField], onChange: function (e) { return _this.changeTail(e, tailField); } }))
                    ];
                }
            }
            return React.createElement(antd_1.Form.Item, { style: itemStyle, label: formItemLabel, className: formItemClass }, getFieldDecorator(column.field, { initialValue: initialValue, rules: rules, valuePropName: valuePropName })(_this.inputElement(column)));
        };
        //构建分组表单项
        _this.buildGroups = function () {
            var _a = _this.props, _b = _a.group, panels = _b.panels, other = _b.other, columns = _a.columns;
            var allGroupFields = _.flatten(_.map(panels, function (d) { return formatFields(d.fields).split(','); }));
            var otherColumns = _.filter(columns, function (c) { return !_.includes(allGroupFields, c.field); });
            defaultGroupKey = _.map(panels, function (d, i) { return i; });
            var hasOther = (other !== false && !_.isEmpty(otherColumns));
            hasOther && defaultGroupKey.push('_other_group');
            return React.createElement(antd_1.Collapse, { className: 'vform-group', accordion: false, bordered: false, onChange: function (d) { return _this.setState({ activeKey: d }, function () { return _.get(_this.props, 'isClose') === true && _this.changeItemWitdh(); }); }, activeKey: _this.state.activeKey },
                panels.map(function (g, i) {
                    var fieldsList = formatFields(g.fields).split(',').map(function (d) { return d.trim(); });
                    var columnsG = _.filter(columns, function (c) { return _.includes(fieldsList, c.field); });
                    if (_.isEmpty(columnsG)) {
                        return null;
                    }
                    return [
                        React.createElement(antd_1.Collapse.Panel, { header: React.createElement("span", { className: 'group-title' },
                                React.createElement("span", null, g.title),
                                React.createElement(antd_1.Icon, { type: "double-right", className: 'group-title-animation', title: '\u5C55\u5F00' })), key: i, showArrow: false }, columnsG.map(function (column) { return _this.buildColumn(column); }))
                    ];
                }),
                hasOther && React.createElement(antd_1.Collapse.Panel, { header: React.createElement("span", { className: 'group-title' },
                        React.createElement("span", null, other || '其他'),
                        React.createElement(antd_1.Icon, { type: "double-right", className: 'group-title-animation', title: '\u5C55\u5F00' })), key: '_other_group', showArrow: false }, otherColumns.map(function (column) { return _this.buildColumn(column); })));
        };
        //构建提交按钮
        _this.buildFooter = function () {
            if (_this.props.onValuesChange) {
                return;
            }
            var footerStyle = {
                justifyContent: _.includes(_this.props.footPosition, 'left') ? 'flex-start' : 'flex-end',
                marginTop: _this.props.group ? 12 : 0,
                paddingLeft: _.includes(_this.props.footPosition, 'left') ? (_this.props.labelWidth || 120) : 0,
                paddingRight: _this.props.gutter || 12
            };
            return React.createElement(antd_1.Row, { className: 'vform-item vform-item-footer', style: footerStyle },
                React.createElement("div", null, _this.props.footer ? _this.props.footer(_this.props.form.getFieldsValue()) : ([
                    _this.props.cancelText !== false && (_this.props.cancelPopover ? React.createElement(antd_1.Popconfirm, { onConfirm: _this.onCancle, title: '\u662F\u5426\u53D6\u6D88\u5DF2\u4FEE\u6539\u7684\u5185\u5BB9?' },
                        React.createElement(antd_1.Button, { style: { marginRight: 12 } }, _this.props.cancelText || '取消')) : React.createElement(antd_1.Button, { style: { marginRight: 12 }, type: _this.props.cancelType ? _this.props.cancelType : 'default', onClick: _this.onCancle }, _this.props.cancelText || '取消')),
                    _this.props.okText !== false && React.createElement(antd_1.Button, { type: _this.props.okType ? _this.props.okType : 'primary', htmlType: 'submit' }, _this.props.okText || '确定')
                ])));
        };
        //格式化提交值，数组改字符串，属性分开
        _this.setValues = function (values) {
            var newValues = _.assign({}, _this.props.default || {}, _this.props.data || {}, values);
            _this.props.columns.map(function (column) {
                if (!_.has(newValues, column.field)) {
                    _.unset(newValues, column.field);
                    return;
                }
                if (_.has(column, 'render')) {
                    newValues[column.field] = _this.renderValuMap.get(column.field);
                }
                var tempValue = newValues[column.field];
                if (column.type == 'prefix-text') {
                    var split = column.field.split(',');
                    if (split.length == 2) {
                        newValues[split[0]] = tempValue[0];
                        newValues[split[1]] = tempValue[1];
                    }
                    else {
                        newValues[column.field] = tempValue.join('');
                    }
                }
                if (column.type === 'checkbox' || column.type === 'select' || column.type === 'cascader' || column.type === 'icon' || column.type === 'selectGroup') {
                    newValues[column.field] = _.concat([], tempValue).join(',');
                }
                else if (column.type === 'multiselect') {
                    if (column.config && column.config.labelInValue) {
                        newValues[column.field] = _.concat([], tempValue).map(function (item) { return item.key; }).join(',');
                    }
                    else {
                        newValues[column.field] = _.concat([], tempValue).join(',');
                    }
                    newValues[column.field] = tempValue;
                }
                else if (column.type === 'switch') {
                    newValues[column.field] = tempValue === true ? column.options[0].value : column.options[1].value;
                }
                else if (column.type === 'date') {
                    newValues[column.field] = moment(tempValue).format(_.get(column, 'config.format') || 'YYYY-MM-DD HH:mm:ss');
                }
                else if (column.type === 'dateNull') {
                    newValues[column.field] = moment(tempValue).format(_.get(column, 'config.format') || 'YYYY-MM-DD HH:mm:ss');
                }
                else if (column.type === 'month') {
                    newValues[column.field] = moment(tempValue).format(_.get(column, 'config.format') || 'YYYY-MM');
                }
                else if (column.type === 'time') {
                    newValues[column.field] = moment(tempValue).format(_.get(column, 'config.format') || 'HH:mm:ss');
                }
                else if (column.type === 'daterange') {
                    var fieldRange = column.field.split(',');
                    var tempValueList = _.isArray(tempValue) ? tempValue : (_.isString(tempValue) ? tempValue.split(',') : []);
                    var start = fieldRange[0].trim();
                    var end = fieldRange[1].trim();
                    newValues[start] = tempValueList[0] ? moment(tempValueList[0]).format(_.get(column, 'config.format') || 'YYYY-MM-DD HH:mm:ss') : '';
                    newValues[end] = tempValueList[1] ? moment(tempValueList[1]).format(_.get(column, 'config.format') || 'YYYY-MM-DD HH:mm:ss') : '';
                    _.unset(newValues, column.field);
                }
                if (_.has(column, 'tail')) {
                    if (_.isObject(column.tail) && _.get(column, 'tail.field')) {
                        newValues[column.tail.field] = _this.state.tailValue[column.tail.field] || '';
                    }
                    else {
                        var itemValue = newValues[column.field];
                        var tailValue = _this.state.tailValue[column.field];
                        var tailType = _.get(column, 'tail.type');
                        var separator = _.get(column, 'tail.separator') || default_separator;
                        if (_.isArray(tailType)) {
                            tailValue = _.includes(tailType, itemValue) ? (tailValue ? "".concat(separator).concat(tailValue) : '') : '';
                            newValues[column.field] = (itemValue || '') + tailValue;
                        }
                        else {
                            newValues[column.field] = (itemValue || '') + (tailValue ? "".concat(separator).concat(tailValue) : '');
                        }
                    }
                }
            });
            return newValues;
        };
        //提交表单
        _this.onSubmit = function (e) { return __awaiter(_this, void 0, void 0, function () {
            var result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        e.preventDefault();
                        result = false;
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                _this.props.form.validateFields(function (err, values) {
                                    if (err) {
                                        console.info('err', err);
                                        resolve(false);
                                    }
                                    var reValues = _this.setValues(values);
                                    resolve(reValues);
                                });
                            })];
                    case 1:
                        result = _a.sent();
                        if (result) {
                            this.props.onOk && this.props.onOk(result);
                        }
                        return [2 /*return*/, result];
                }
            });
        }); };
        //取消修改，重置初始化值
        _this.onCancle = function (e) {
            if (_this.props.onCancel) {
                _this.props.onCancel(e);
            }
            else {
                _this.setInitialValue();
                _this.setState({ tailValue: {} });
            }
        };
        //二级弹窗ok
        _this.onModalOk = function (v) {
            var _a;
            var column = _this.state.column;
            var submitModalValue = v;
            if (_.has(column, 'render')) {
                submitModalValue = column['render'](v);
                _this.renderValuMap.set(column.field, v);
            }
            _this.props.form.setFieldsValue((_a = {}, _a[column.field] = submitModalValue, _a));
            _.get(_this.state.column, 'subConfig.onOk') && _.get(_this.state.column, 'subConfig.onOk')(v);
            _.has(_this.state.column, 'link') && _this.changeLink(_this.state.column, v);
            _this.setState({ column: {}, showVForm: false, showSelectModal: false }, function () {
                modalValue = '';
            });
        };
        //二级弹窗cancel
        _this.onModalCancel = function () {
            modalValue = '';
            _.get(_this.state.column, 'subConfig.onCancel') && _.get(_this.state.column, 'subConfig.onCancel');
            _this.setState({ column: {}, showVForm: false, showSelectModal: false });
        };
        return _this;
    }
    FromContent.prototype.componentDidMount = function () {
        var _this = this;
        this.setInitLinkValue();
        this.getInitTailValue();
        this.setState({ activeKey: defaultGroupKey }, function () { return _this.props.labelWidth && _this.changeItemWitdh(); });
    };
    FromContent.prototype.componentDidUpdate = function (prevProps) {
        var _this = this;
        if (((prevProps.labelWidth && !_.isEqual(prevProps.labelWidth, this.props.labelWidth)) || !_.isEqual(prevProps.columns, this.props.columns))) {
            this.changeItemWitdh();
        }
        if (_.has(this.props, 'isClose') && !_.isEqual(prevProps.isClose, this.props.isClose)) {
            this.setState({ activeKey: _.get(this.props, 'isClose') === true ? [] : defaultGroupKey }, function () { return _.get(_this.props, 'isClose') !== true && _this.changeItemWitdh(); });
        }
        if (!_.isEqual(prevProps.formKey, this.props.formKey) || !_.isEqual(prevProps.data, this.props.data)) {
            this.setInitialValue();
        }
    };
    FromContent.prototype.componentWillUnmount = function () {
        this.renderValuMap = new Map();
    };
    //初始化Tail尾部值
    FromContent.prototype.getInitTailValue = function () {
        var defaultData = _.assign({}, this.props.default || {}, this.props.data || {});
        var tailValue = {};
        this.props.columns.map(function (column) {
            var _a, _b;
            if (_.has(column, 'tail')) {
                if (_.isObject(column.tail) && _.get(column, 'tail.field')) {
                    var field = column.tail.field;
                    tailValue = _.extend({}, tailValue, (_a = {}, _a[field] = defaultData[field] || '', _a));
                }
                else {
                    var value = defaultData[column.field] || '';
                    var separator = _.get(column, 'tail.separator') || default_separator;
                    var tailIndex = "".concat(value).lastIndexOf(separator);
                    if (tailIndex > -1) {
                        var tailV = "".concat(value).substr(tailIndex + separator.length);
                        tailValue = _.extend({}, tailValue, (_b = {}, _b[column.field] = tailV || '', _b));
                    }
                }
            }
        });
        this.setState({ tailValue: tailValue });
    };
    FromContent.prototype.formItems = function (column) {
        var _this = this;
        return this.addFormItemIds[column.field].map(function (k, index) {
            var _columns = _.extend({}, column);
            _columns.field = _columns.field + k;
            return _this.buildColumn(column);
        });
    };
    FromContent.prototype.addItemColumn = function (column) {
        var _this = this;
        if (!_.has(this.addFormItemIds, column.field)) {
            this.addFormItemIds[column.field] = [];
        }
        var getFieldDecorator = this.props.form.getFieldDecorator;
        //支持增减组件
        if (_.has(column, 'addItem') && column.addItem) {
            getFieldDecorator(column.field, { initialValue: [] });
            return React.createElement(React.Fragment, null,
                this.formItems(column),
                React.createElement(antd_1.Form.Item, __assign({}, formItemLayoutWithOutLabel),
                    React.createElement(antd_1.Button, { type: "dashed", onClick: function () { return _this.add(column.field); }, style: { width: '60%' } },
                        React.createElement(antd_1.Icon, { type: "plus" }),
                        " Add field")));
        }
    };
    FromContent.prototype.render = function () {
        var _this = this;
        return React.createElement(React.Fragment, null,
            React.createElement(antd_1.Form, { className: 'vap-vform', onSubmit: this.onSubmit, key: this.props.formKey },
                React.createElement(antd_1.Row, { className: 'vform-container ' + (this.props.layout == 'leftText' ? 'layout-leftText' : '') + (this.props.layout == 'table' ? 'layout-table' : '') },
                    this.props.group && this.buildGroups(),
                    !this.props.group && this.props.columns.map(function (column) {
                        if (column.addItem) {
                            return _this.addItemColumn(column);
                        }
                        return _this.buildColumn(column);
                    }),
                    this.buildFooter())),
            React.createElement(VFormModal_1.default, __assign({ visible: this.state.showVForm, title: "\u8BF7\u586B\u5199\"".concat(_.get(this.state.column, 'title'), "\"\u7684\u503C"), columns: [] }, (_.get(this.state.column, 'subConfig') || {}), { onCancel: function () { return _this.onModalCancel(); }, onOk: function (v) { return _this.onModalOk(v); } })),
            this.state.showSelectModal && React.createElement(_SelectModal_1.default, __assign({ visible: this.state.showSelectModal }, (_.get(this.state.column, 'subConfig.selectModalProps') || {}), { data: this.renderValuMap.has(this.state.column.field) ? this.renderValuMap.get(this.state.column.field) : (this.props.form.getFieldValue(this.state.column.field) || this.getInitialValue(this.state.column)), onCancel: function () { return _this.onModalCancel(); }, onOk: function (v) { return _this.onModalOk(v); } })));
    };
    return FromContent;
}(React.PureComponent));
var VForm = antd_1.Form.create({ onValuesChange: function (props, changedValues, allValues) { return props.onValuesChange && props.onValuesChange(allValues); } })(FromContent);
exports.default = VForm;
