"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var _ = require("lodash");
//增量唯一key
var addkey = (function (key) {
    if (key === void 0) { key = 1; }
    return function () { return key++; };
})();
//可编辑标签
var EditTag = /** @class */ (function (_super) {
    __extends(EditTag, _super);
    function EditTag() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EditTag.prototype.render = function () {
        var _this = this;
        var _a = this.props, data = _a.data, renderItem = _a.renderItem, closable = _a.closable, addButton = _a.addButton, onRowClick = _a.onRowClick, onAddClick = _a.onAddClick, onDeleteClick = _a.onDeleteClick;
        return React.createElement("div", null,
            data.map(function (item, i) {
                var param = _.has(item, '_color') ? { color: item['_color'] } : {};
                return React.createElement(antd_1.Tag, __assign({}, param, { key: addkey(), closable: !_this.props.disabled && closable, onClose: function () { return onDeleteClick && onDeleteClick(item, i, data); }, onClick: function () { return onRowClick && onRowClick(item, i); } }), renderItem ? renderItem(item, i) : i);
            }),
            (!_.isNil(addButton) && addButton) && (_.isString(addButton) ?
                React.createElement(antd_1.Button, { disabled: this.props.disabled, size: 'small', icon: 'plus', onClick: function (e) { return onAddClick && onAddClick(_this.props.data); } }, addButton || '添加')
                : React.createElement("span", { onClick: function (e) { return !_this.props.disabled && onAddClick && onAddClick(_this.props.data); } }, addButton)));
    };
    return EditTag;
}(React.PureComponent));
exports.default = EditTag;
