"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectWrapper = void 0;
var React = require("react");
var antd_1 = require("antd");
var VRow_1 = require("../../admin/Layout1/VRow");
var VCol_1 = require("../../admin/Layout1/VCol");
var utils_1 = require("../../utils");
var _ = require("lodash");
// import { PaginationProps } from 'antd/lib/pagination/Pagination';
var UPagination_1 = require("../UPagination");
var zh_ch = window.antd.locales.zh_CN;
//空值排序
var sortNull = function (list) {
    if (list === void 0) { list = []; }
    return _.reverse(list.sort());
};
//格式化get请求参数
var transGetParam = function (obj) {
    if (!obj) {
        return '';
    }
    var param = [];
    try {
        _.keys(obj).map(function (key) { return param.push(key + '=' + JSON.stringify(obj[key])); });
    }
    catch (e) { }
    return _.isEmpty(param) ? '' : ('?' + param.join('&'));
};
//动态树节点
var renderDynamicNode = function (data, nameField, valueField, leafRender, renderItem) {
    return _.map(data, function (d, i) {
        var title = renderItem ? renderItem(d, i) : d[nameField];
        if (d.children && d.children.length > 0) {
            return React.createElement(antd_1.Tree.TreeNode, { title: title, dataRef: d, key: d[valueField], isLeaf: leafRender && leafRender(d) }, renderDynamicNode(d.children, nameField, valueField, leafRender));
        }
        return React.createElement(antd_1.Tree.TreeNode, { title: title, dataRef: d, key: d[valueField], isLeaf: leafRender && leafRender(d) });
    });
};
//静态树节点
var renderStaticNode = function (data, nameField, valueField, upField, rootValue, renderItem) {
    if (upField === void 0) { upField = 'value'; }
    var loop = function (list) {
        return _.map(list, function (item, i) {
            var children = (item.children && !_.isEmpty(item.children)) ? item.children : _.concat([], _.filter(data, function (d) { return (d[upField] + '') === (item[valueField]) + ''; }));
            item['key'] = item[valueField];
            item['title'] = renderItem ? renderItem(item, i) : item[nameField];
            item['children'] = children.length > 0 ? loop(children) : [];
            return item;
        });
    };
    var roots = _.filter(data, function (d) { return (d[upField] == rootValue || (!d[upField] && !rootValue)); });
    return _.isEmpty(roots) ? loop(data) : loop(roots);
};
// 将children恢复成同一级
var transChildren = function (list) {
    var result = [];
    var loop = function (data) {
        _.forEach(data, function (item) {
            result.push(item);
            if (_.has(item, 'children') && _.isArray(item.children)) {
                loop(item.children);
            }
        });
    };
    loop(list);
    return result;
};
//默认最大参数
var MAX_COUNT = 99999;
/**
 * 多数据选择弹窗，少数据可用Select、Checkbox、Radio等
 * 可用于构造 Tag | Checkbox | List | 动态静态Tree | 左右二级联动List 等展示格式，提供页面搜索功能
 */
var SelectWrapper = /** @class */ (function (_super) {
    __extends(SelectWrapper, _super);
    function SelectWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            options: [],
            filterOptions: [],
            inputValue: '',
            selectKeys: [],
            allChecked: false,
            isExpand: false,
            subAllChecked: false,
            subClick: '',
            count_: 0,
            start_: 0,
            total: 0, //存在query时总数
        };
        _this.optionsMap = new Map();
        _this.nameField = 'name';
        _this.valueField = 'value';
        _this.typeName = '对象';
        _this.superOptions = [];
        _this.superSubField = '';
        _this.superTypeName = '';
        _this.multy = true;
        _this.defaultExpandAll = true;
        _this.defaultExpandedKeys = [];
        _this.rootApi = '';
        _this.leafApi = '';
        _this.isLeaf = '';
        _this.rootValue = '';
        _this.treeOptions = []; //专门用于动态树的搜索
        //传出值
        _this.change = function () {
            var names = _.map(_.filter(_this.state.selectKeys, function (d) { return _this.optionsMap.has(d + ''); }), function (key) { return _this.optionsMap.get(key)[_this.nameField]; });
            _this.props.onChange && _this.props.onChange(_this.state.selectKeys, names);
        };
        //初始化传入props、options、data
        _this.init = function () {
            _this.nameField = _this.props.nameField || 'name';
            _this.valueField = _this.props.valueField || 'value';
            _this.typeName = _this.props.typeName || '对象';
            _this.superOptions = _.get(_this.props, 'super.options') || [];
            _this.superSubField = _.get(_this.props, 'super.subField') || '';
            _this.superTypeName = _.get(_this.props, 'super.typeName') || '';
            _this.multy = _this.props.multy !== false;
            _this.defaultExpandAll = _this.props.defaultExpandAll !== false;
            _this.defaultExpandedKeys = _this.props.defaultExpandedKeys || [];
            _this.rootApi = _.get(_this.props, 'queryTree.rootApi') || '/api-common/organization/root/';
            _this.leafApi = _.get(_this.props, 'queryTree.leafApi') || '/api-common/organization/tree/';
            _this.isLeaf = _.get(_this.props, 'queryTree.isLeaf') || '';
            _this.rootValue = _.get(_this.props, 'queryTree.rootValue') || '';
            var data = (_.isString(_this.props.data) && _this.props.data) ? _this.props.data.split(',') : ((_.isArray(_this.props.data) && !_.isEmpty(_this.props.data)) ? _this.props.data : []);
            _this.setOptions(data);
        };
        //初始化options
        _this.setOptions = function (data) { return __awaiter(_this, void 0, void 0, function () {
            var queryOptions, options;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = data || this.state.selectKeys;
                        queryOptions = [];
                        if (!(this.props.type == 'tree' && this.props.queryTree)) return [3 /*break*/, 3];
                        if (!_.has(this.props.queryTree, 'rootApi')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getTreeData()];
                    case 1:
                        queryOptions = _a.sent();
                        _a.label = 2;
                    case 2: return [3 /*break*/, 5];
                    case 3:
                        if (!this.props.query) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.getData()];
                    case 4:
                        queryOptions = _a.sent();
                        _a.label = 5;
                    case 5:
                        options = transChildren(_.map(_.differenceBy(_.concat([], queryOptions, this.props.options || []), this.superOptions, this.valueField), function (item) { item[_this.valueField] = item[_this.valueField] + ''; return item; }));
                        _.forEach(options, function (item) { return _this.optionsMap.set(item[_this.valueField] + '', item); });
                        this.treeOptions = _.concat([], options);
                        this.setState({ options: options, filterOptions: options, selectKeys: data }, function () { return _this.change(); });
                        return [2 /*return*/];
                }
            });
        }); };
        //通过接口获取在线数据
        _this.getData = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, api, param, _b, method, resp, count_, data;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.props.query, api = _a.api, param = _a.param, _b = _a.method, method = _b === void 0 ? 'get' : _b;
                        resp = '';
                        count_ = this.state.count_ || param['count_'] || MAX_COUNT;
                        if (!(method == 'get')) return [3 /*break*/, 2];
                        api = (_.endsWith(api, '/') ? api : (api + '/')) + transGetParam(param);
                        return [4 /*yield*/, utils_1.Ajax.GET(api)];
                    case 1:
                        resp = _c.sent();
                        return [3 /*break*/, 4];
                    case 2:
                        param['count_'] = count_;
                        param['start_'] = this.state.start_ || 0;
                        return [4 /*yield*/, utils_1.Ajax.POST(api, param)];
                    case 3:
                        resp = _c.sent();
                        _c.label = 4;
                    case 4:
                        if (resp && _.get(resp, 'code') == '0') {
                            data = resp.data || resp.list || [];
                            if (_.get(resp, 'total')) {
                                this.setState({ total: resp.total, count_: count_ });
                            }
                            return [2 /*return*/, data];
                        }
                        return [2 /*return*/, []];
                }
            });
        }); };
        //动态加载子节点
        _this.loadTreeData = function (node) { return __awaiter(_this, void 0, void 0, function () {
            var children;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (node.props.children) {
                            return [2 /*return*/, null];
                        }
                        return [4 /*yield*/, this.getTreeData(node.props.dataRef.code)];
                    case 1:
                        children = _a.sent();
                        node.props.dataRef.children = children;
                        this.treeOptions = _.union(this.treeOptions, children);
                        this.setState({ options: __spreadArray([], __read(this.state.options), false) });
                        return [2 /*return*/, null];
                }
            });
        }); };
        //获取子节点数据
        _this.getTreeData = function (code) { return __awaiter(_this, void 0, void 0, function () {
            var api, resp, list, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = code ? (this.leafApi + code) : this.rootApi;
                        return [4 /*yield*/, utils_1.Ajax.GET(api)];
                    case 1:
                        resp = _a.sent();
                        list = [];
                        if (resp.code == 0 || _.has(resp, 'children')) {
                            data = _.has(resp, 'children') ? resp : (resp.data || resp.list);
                            list = _.concat([], data);
                            this.setState({ total: this.state.total + list.length });
                        }
                        return [2 /*return*/, list];
                }
            });
        }); };
        //判断单个项目是否选中
        _this.hasCheck = function (value) { return _.includes(_this.state.selectKeys, value + ''); };
        //搜索下栏的checkbox
        _this.onSearchCheck = function (e) {
            var keys = _.isEmpty(_this.state.filterOptions) ? _.map(_this.state.options, function (item) { return (item[_this.valueField] + ''); }) : _.map(_this.state.filterOptions, function (item) { return (item[_this.valueField] + ''); });
            _this.setState({ selectKeys: e.target.checked ? _.union(_this.state.selectKeys, keys) : _.difference(_this.state.selectKeys, keys), allChecked: e.target.checked });
        };
        //选择全部
        _this.onAllSelectClick = function (isAll) {
            var keys = _.map(_this.state.filterOptions, function (item) { return (item[_this.valueField] + ''); });
            _this.setState({ selectKeys: isAll ? _.union(_this.state.selectKeys, keys) : _.difference(_this.state.selectKeys, keys) });
        };
        // 反向选择
        _this.onInvertSelect = function () {
            var keys = _.map(_this.state.filterOptions, function (item) { return (item[_this.valueField] + ''); });
            var uns = _.union(keys, _this.state.selectKeys); //1并集
            var ins = _.intersection(_this.state.selectKeys, keys); //2交集
            _this.setState({ selectKeys: _.difference(uns, ins) }); //3差集
        };
        //搜索处对象选中
        _this.onSearchClick = function (item) {
            if (_this.multy) {
                _this.setState({ selectKeys: _this.hasCheck(item[_this.valueField] + '') ? _.filter(_this.state.selectKeys, function (d) { return d != item[_this.valueField]; }) : _.concat([], _this.state.selectKeys, item[_this.valueField] + '') });
            }
            else {
                _this.setState({ selectKeys: _.concat([], item[_this.valueField] + '') });
            }
        };
        //已选对象删除
        _this.onItemClose = function (item) { return _this.setState({ selectKeys: _.filter(_this.state.selectKeys, function (d) { return d != item[_this.valueField] + ''; }) }); };
        //已选对象清除
        _this.onItemDelete = function () { return _this.setState({ selectKeys: [], isExpand: false }); };
        //List选择
        _this.onListSelect = function (item) {
            if (_this.multy) {
                _this.setState({ selectKeys: _this.hasCheck(item[_this.valueField]) ? _.filter(_this.state.selectKeys, function (d) { return d != item[_this.valueField]; }) : _.concat([], _this.state.selectKeys, item[_this.valueField] + '') });
            }
            else {
                _this.setState({ selectKeys: _this.hasCheck(item[_this.valueField]) ? [] : _.concat([], item[_this.valueField] + '') });
            }
        };
        //Tag选择
        _this.onTagSelect = function (checked, item) {
            if (_this.multy) {
                _this.setState({ selectKeys: checked ? _.concat([], _this.state.selectKeys, item[_this.valueField] + '') : _.filter(_this.state.selectKeys, function (d) { return d != (item[_this.valueField] + ''); }) });
            }
            else {
                _this.setState({ selectKeys: checked ? _.concat([], item[_this.valueField] + '') : [] });
            }
        };
        //Checkbox选择
        _this.onCheckboxSelect = function (keys, allFilterKeys) {
            if (_this.multy) {
                var diff = _.difference(_this.state.selectKeys, allFilterKeys); //1差集
                _this.setState({ selectKeys: _.union(diff, keys) }); //2并集
            }
            else {
                _this.setState({ selectKeys: _.isEmpty(keys) ? [] : _.concat([], keys[keys.length - 1]) });
            }
        };
        //子列表全选
        _this.onSubCheck = function (e, subOptions) {
            var keys = _.map(subOptions, function (item) { return (item[_this.valueField] + ''); });
            _this.setState({ selectKeys: e.target.checked ? _.union(_this.state.selectKeys, keys) : _.difference(_this.state.selectKeys, keys), subAllChecked: e.target.checked });
        };
        //树节点选择
        _this.onTreeSelect = function (selectKeys) { _this.setState({ selectKeys: selectKeys }); };
        //渲染已选择字段
        _this.renderHasSelect = function () {
            var _a = _this.state, options = _a.options, filterOptions = _a.filterOptions;
            var selectOptions = !_.isEmpty(_this.optionsMap) ? _.map(_this.state.selectKeys, function (d) { return _this.optionsMap.get(d + ''); }) : _.filter(options, function (item) { return _this.hasCheck(item[_this.valueField]); });
            selectOptions = _.filter(selectOptions, function (d) { return !!d; });
            return React.createElement("div", { className: 'has-selected-display' },
                React.createElement("div", { className: 'has-selected-search' },
                    React.createElement(antd_1.Input, { placeholder: "\u67E5\u627E".concat(_this.typeName), autoComplete: 'off', onChange: function (e) {
                            var _options = !_.isString(_this.isLeaf) ? _this.treeOptions : options;
                            _this.setState({ inputValue: e.target.value, filterOptions: e.target.value ? _.filter(_options, function (item) { return _.includes(item[_this.nameField], e.target.value); }) : _options, allChecked: false });
                        } }),
                    (_this.props.searchType !== 'filter' && _this.state.inputValue != '') && filterOptions.map(function (item) { return React.createElement("a", { title: item[_this.nameField] + ':' + item[_this.valueField], onClick: function () { return _this.onSearchClick(item); } }, item[_this.nameField]); })),
                _this.props.type !== 'tree' && React.createElement(antd_1.Alert, { className: 'has-selected-item', message: React.createElement("span", null,
                        "\u5F53\u524D\u9875",
                        _this.typeName,
                        _this.multy ? React.createElement(antd_1.Checkbox, { onChange: function (e) { return _this.onAllSelectClick(e.target.checked); } },
                            React.createElement("b", { title: '\u70B9\u51FB\u9009\u4E2D\u5F53\u524D\u9875' }, filterOptions.length)) : React.createElement("b", null, filterOptions.length),
                        " \u4E2A",
                        _this.multy ? React.createElement("b", null,
                            ", ",
                            React.createElement("a", { title: '\u53CD\u5411\u9009\u62E9', onClick: function () { return _this.onInvertSelect(); } }, "\u53CD\u9009"),
                            " \u3002") : ' 。',
                        "\u5DF2\u9009 ",
                        React.createElement("b", null,
                            (_this.multy && !_.isEmpty(_this.state.selectKeys)) ? React.createElement("a", { title: "".concat(_this.state.isExpand ? '收起' : '查看', "\u5DF2\u9009").concat(_this.typeName), onClick: function () { return _this.setState({ isExpand: !_this.state.isExpand }); } }, _this.state.selectKeys.length) : _this.state.selectKeys.length,
                            " "),
                        " \u4E2A\u3002",
                        _this.multy && !_.isEmpty(_this.state.selectKeys) && _this.state.isExpand && React.createElement("div", { className: 'has-selected-tag' },
                            selectOptions.map(function (item) { return React.createElement(antd_1.Tag, { key: item[_this.valueField] + '', closable: true, onClose: function () { return _this.onItemClose(item); } }, item[_this.nameField]); }),
                            React.createElement(antd_1.Popconfirm, { title: "\u786E\u8BA4\u6E05\u9664\u5DF2\u9009\u62E9\u7684".concat(_this.typeName, "\u5417?"), onConfirm: _this.onItemDelete },
                                React.createElement("a", { style: { color: '#f5222d' } }, " \u6E05\u9664 ")))) }));
        };
        //渲染成List
        _this.renderList = function (opts) {
            if (opts === void 0) { opts = []; }
            return !_.isEmpty(opts) && React.createElement(antd_1.List, { style: { maxHeight: 500, overflow: 'auto' }, size: 'small', bordered: true, dataSource: opts, renderItem: function (item, i) {
                    return React.createElement(antd_1.List.Item, { actions: [React.createElement(antd_1.Button, { size: 'small', type: _this.hasCheck(item[_this.valueField]) ? 'primary' : 'default', onClick: function () { return _this.onListSelect(item); } }, "\u9009\u62E9")] }, _this.props.renderItem ? _this.props.renderItem(item, i) : item[_this.nameField]);
                } });
        };
        //渲染成Tag
        _this.renderTag = function (opts) {
            var style = _this.props.span ? { flexBasis: "calc(".concat(100 / _this.props.span, "% - 4px)"), marginRight: 4 } : {};
            if (_.has(_this.props, 'classify')) {
                var _a = _this.props.classify, field = _a.field, _b = _a.render, render_1 = _b === void 0 ? (function (v) { return v; }) : _b, other_1 = _a.other;
                var group_1 = _.groupBy(opts, field);
                return React.createElement("div", { className: 'can-select-display' }, _.map(sortNull(_.keys(group_1)), function (d) { return React.createElement(React.Fragment, null,
                    React.createElement("div", { className: 'classify-label' }, d ? render_1(d) : (other_1 || '其他')),
                    _.map(group_1[d], function (item, i) { return React.createElement(antd_1.Tag.CheckableTag, { style: style, checked: _this.hasCheck(item[_this.valueField]), onChange: function (checked) { return _this.onTagSelect(checked, item); } }, _this.props.renderItem ? _this.props.renderItem(item, i) : item[_this.nameField]); })); }));
            }
            return !_.isEmpty(opts) && React.createElement("div", { className: 'can-select-display' }, _.map(opts, function (item, i) { return React.createElement(antd_1.Tag.CheckableTag, { style: style, checked: _this.hasCheck(item[_this.valueField]), onChange: function (checked) { return _this.onTagSelect(checked, item); } }, _this.props.renderItem ? _this.props.renderItem(item, i) : item[_this.nameField]); }));
        };
        //渲染成Checkbox
        _this.renderCheckbox = function (opts) {
            var allFilterKeys = _.map(opts, function (item) { return (item[_this.valueField] + ''); });
            var style = _this.props.span ? { flexBasis: "calc(".concat(100 / _this.props.span, "% - 4px)"), marginRight: 4 } : {};
            if (_.has(_this.props, 'classify')) {
                var _a = _this.props.classify, field = _a.field, _b = _a.render, render_2 = _b === void 0 ? (function (v) { return v; }) : _b, other_2 = _a.other;
                var group_2 = _.groupBy(opts, field);
                return React.createElement(antd_1.Checkbox.Group, { className: 'can-select-display', value: _this.state.selectKeys, onChange: function (keys) { return _this.onCheckboxSelect(keys, allFilterKeys); } }, _.map(sortNull(_.keys(group_2)), function (d) { return React.createElement(React.Fragment, null,
                    React.createElement("div", { className: 'classify-label' }, d ? render_2(d) : (other_2 || '其他')),
                    _.map(group_2[d], function (item, i) { return React.createElement(antd_1.Checkbox, { style: style, checked: _this.hasCheck(item[_this.valueField]), value: item[_this.valueField] + '', key: item[_this.valueField] },
                        React.createElement("span", { title: item[_this.nameField] }, _this.props.renderItem ? _this.props.renderItem(item, i) : React.createElement("span", { title: item[_this.nameField] }, item[_this.nameField]))); })); }));
            }
            return !_.isEmpty(opts) && React.createElement(antd_1.Checkbox.Group, { className: 'can-select-display', value: _this.state.selectKeys, onChange: function (keys) { return _this.onCheckboxSelect(keys, allFilterKeys); } }, _.map(opts, function (item, i) { return React.createElement(antd_1.Checkbox, { style: style, checked: _this.hasCheck(item[_this.valueField]), value: item[_this.valueField] + '', key: item[_this.valueField] },
                React.createElement("span", { title: item[_this.nameField] }, _this.props.renderItem ? _this.props.renderItem(item, i) : React.createElement("span", { title: item[_this.nameField] }, item[_this.nameField]))); }));
        };
        //渲染成动态树
        _this.renderDynamicTree = function (opts) {
            return !_.isEmpty(opts) && React.createElement(antd_1.Tree, { showLine: true, defaultExpandAll: _this.defaultExpandAll, defaultExpandedKeys: _this.defaultExpandedKeys, selectedKeys: _this.state.selectKeys, multiple: _this.multy, loadData: _this.loadTreeData, onSelect: _this.onTreeSelect }, renderDynamicNode(opts, _this.nameField, _this.valueField, _this.isLeaf, _this.props.renderItem));
        };
        //渲染成静态树
        _this.renderStaticTree = function (opts) {
            var upField = _this.isLeaf.toString() || _this.valueField;
            return !_.isEmpty(opts) && React.createElement(antd_1.Tree, { showLine: true, defaultExpandAll: _this.defaultExpandAll, defaultExpandedKeys: _this.defaultExpandedKeys, selectedKeys: _this.state.selectKeys, multiple: _this.multy, onSelect: _this.onTreeSelect, treeData: renderStaticNode(opts, _this.nameField, _this.valueField, upField, _this.rootValue, _this.props.renderItem) });
        };
        //渲染成左右二级选择
        _this.renderSuperFilter = function () {
            var renderItem = _this.props.super.renderItem;
            var options = _this.state.options;
            var subOptions = _.filter(options, function (d) { return (d[_this.superSubField] == _this.state.subClick); });
            return React.createElement(VRow_1.default, null,
                React.createElement(VCol_1.default, { span: 8, title: "\u70B9\u51FB".concat(_this.superTypeName), bodyStyle: { maxHeight: 500, overflow: 'auto' } },
                    React.createElement(antd_1.Table, { className: 'vap-table', size: 'small', pagination: false, dataSource: _this.superOptions, columns: [
                            { title: '序号', dataIndex: '', render: function (t, r, i) { return i + 1; } },
                            { title: _this.superTypeName, dataIndex: _this.nameField, render: function (t, r, i) { return (renderItem ? renderItem(r, i) : (t || r[_this.valueField])); } }
                        ], onRowClick: function (record, i) { return _this.setState({ subClick: record[_this.valueField] + '', subAllChecked: false }); }, rowClassName: function (record) { return record[_this.valueField] == _this.state.subClick ? 'vform-row-select' : ''; } })),
                React.createElement(VCol_1.default, { span: 16, title: "\u9009\u62E9".concat(_this.typeName), bodyStyle: { overflow: 'hidden' }, actions: [
                        _this.multy && React.createElement(antd_1.Checkbox, { checked: _this.state.subAllChecked, onChange: function (e) { return _this.onSubCheck(e, subOptions); } })
                    ] }, _this.renderList(subOptions)));
        };
        //渲染底部翻页组件，只有post请求才会分页
        _this.renderPagination = function () {
            if (_.get(_this.props.query, 'method') !== 'post' || _this.props.type === 'tree') {
                return null;
            }
            return React.createElement(UPagination_1.default, { pageSize: _this.state.count_, pageSizeOptions: ['10', '20', '50', '100', '200', '500'], showSizeChanger: true, total: _this.state.total, current: Math.floor(_this.state.start_ / _this.state.count_) + 1, onChange: function (page, pageSize) { _this.setState({ start_: (page - 1) * pageSize, count_: pageSize }, function () { return _this.setOptions(); }); }, onShowSizeChange: function (current, size) { _this.setState({ count_: size, start_: 0 }, function () { return _this.setOptions(); }); } });
        };
        return _this;
    }
    SelectWrapper.prototype.componentDidMount = function () {
        this.init();
    };
    SelectWrapper.prototype.componentDidUpdate = function (old, oldState) {
        if (!_.isEqual(old.data, this.props.data)) {
            this.init();
        }
        if (!_.isEqual(oldState.selectKeys, this.state.selectKeys)) {
            this.change();
        }
    };
    SelectWrapper.prototype.render = function () {
        var _a = this.props.type, type = _a === void 0 ? 'checkbox' : _a;
        var opts = _.concat([], this.props.searchType !== 'filter' ? this.state.options : this.state.filterOptions);
        return React.createElement(React.Fragment, null,
            this.renderHasSelect(),
            this.props.super ? this.renderSuperFilter() : React.createElement(React.Fragment, null,
                type == 'list' && this.renderList(opts),
                type == 'tag' && this.renderTag(opts),
                type == 'checkbox' && this.renderCheckbox(opts),
                type == 'tree' && React.createElement("div", { style: { maxHeight: 500, overflow: 'auto' } }, _.isString(this.isLeaf) ? this.renderStaticTree(opts) : this.renderDynamicTree(opts))),
            this.renderPagination());
    };
    return SelectWrapper;
}(React.PureComponent));
exports.SelectWrapper = SelectWrapper;
var SelectModal = /** @class */ (function (_super) {
    __extends(SelectModal, _super);
    function SelectModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            selectKeys: [],
            names: [],
        };
        return _this;
    }
    SelectModal.prototype.render = function () {
        var _this = this;
        var modalParam = {};
        if (window.VAP_GLOBAL.UFORM.maskClosable == false) {
            modalParam.maskClosable = false;
        }
        return React.createElement(antd_1.Modal, __assign({}, modalParam, { width: this.props.super ? 750 : 450, destroyOnClose: true, closable: false, bodyStyle: { maxHeight: 600, overflow: 'auto' } }, this.props, { className: ' select-modal ' + (this.props.className || ''), onOk: function (e) { _this.props.onOk && _this.props.onOk(_this.state.selectKeys.join(','), _this.state.names.join(',')); }, okText: '\u786E\u5B9A', cancelText: '\u53D6\u6D88' }),
            React.createElement(SelectWrapper, __assign({}, this.props, { onChange: function (vals, nms) { _this.setState({ selectKeys: vals, names: nms }); } })));
    };
    SelectModal.SHOW = function (config) {
        var values = [];
        var names = [];
        antd_1.Modal.confirm(__assign(__assign({ maskClosable: true, icon: null, title: null }, config), { width: config.width || 750, className: "select-modal-info ".concat(config.className || '', " "), content: React.createElement(antd_1.ConfigProvider, { locale: zh_ch },
                React.createElement(SelectWrapper, __assign({}, config, { onChange: function (vals, nms) {
                        values = _.concat([], vals);
                        names = _.concat([], nms);
                    } }))), onOk: function () { return config.onOk && config.onOk(values.join(','), names.join(',')); } }));
    };
    return SelectModal;
}(React.PureComponent));
exports.default = SelectModal;
