"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var Modal = exports.Modal = /** @class */ (function (_super) {
    __extends(Modal, _super);
    function Modal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Modal.prototype.render = function () {
        var _this = this;
        var param = { footer: this.props.footer };
        if (window.VAP_GLOBAL.UFORM.maskClosable == false) {
            param.maskClosable = false;
        }
        if (this.props.footer === undefined) {
            param.footer = [
                React.createElement(antd_1.Button, { loading: this.props.confirmLoading, type: "primary", onClick: function (evt) { return _this.props.onOk(evt); } }, "  \u786E\u5B9A   "),
                React.createElement(antd_1.Button, { onClick: function (evt) { return _this.props.onCancel(evt); } }, " \u53D6\u6D88 ")
            ];
        }
        return React.createElement(antd_1.Modal, __assign({}, this.props, param));
    };
    Modal.destroyAll = antd_1.Modal.destroyAll;
    Modal.info = function (props) { return antd_1.Modal.info(_.extend({ className: 'vap-modal-rerverse', okText: '确定', cancelText: '取消' }, props)); };
    Modal.success = function (props) { return antd_1.Modal.success(_.extend({ className: 'vap-modal-rerverse', okText: '确定', cancelText: '取消' }, props)); };
    Modal.error = function (props) { return antd_1.Modal.error(_.extend({ className: 'vap-modal-rerverse', okText: '确定', cancelText: '取消' }, props)); };
    Modal.warning = function (props) { return antd_1.Modal.warning(_.extend({ className: 'vap-modal-rerverse', okText: '确定', cancelText: '取消' }, props)); };
    Modal.confirm = function (props) { return antd_1.Modal.confirm(_.extend({ className: 'vap-modal-rerverse', okText: '确定', cancelText: '取消' }, props)); };
    return Modal;
}(React.PureComponent));
