"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var utils_1 = require("../../utils");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            type: "0"
        };
        return _this;
    }
    default_1.prototype.componentWillMount = function () {
        var _this = this;
        var data = window.localStorage.getItem("action_bar_type");
        if (data) {
            this.setState({ type: data });
        }
        else {
            utils_1.Ajax.GET('/api-common/system/config', function (res) {
                if (res && res.code == 0) {
                    res.data.forEach(function (element) {
                        if (element.confId == "action_bar_type") {
                            window.localStorage.setItem('action_bar_type', element.confValue + '');
                            _this.setState({ type: element.confValue + '' });
                        }
                    });
                }
            });
        }
    };
    default_1.prototype.componentWillReceiveProps = function (nextProps) {
    };
    default_1.prototype.render = function () {
        var _this = this;
        var res = React.createElement(antd_1.Icon, { type: this.props.type, title: this.props.title, style: this.props.style ? this.props.style : {}, onClick: function () {
                if (!_this.props.onClick) {
                    return;
                }
                _this.props.onClick();
            } });
        if (this.state.type == "1") {
            res = React.createElement("a", { style: this.props.style ? this.props.style : {}, onClick: function () {
                    if (!_this.props.onClick) {
                        return;
                    }
                    _this.props.onClick();
                } }, this.props.title);
        }
        return (React.createElement("div", { style: { display: "inline", marginLeft: this.state.type == "1" ? 10 : 0 } }, res));
    };
    return default_1;
}(React.Component));
exports.default = default_1;
