"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapPath = void 0;
var MAPIDS = [
    { "id": "65", "name": "新疆维吾尔自治区" },
    { "id": "54", "name": "西藏自治区" },
    { "id": "15", "name": "内蒙古自治区" },
    { "id": "63", "name": "青海省" },
    { "id": "51", "name": "四川省" },
    { "id": "23", "name": "黑龙江省" },
    { "id": "62", "name": "甘肃省" },
    { "id": "53", "name": "云南省" },
    { "id": "45", "name": "广西壮族自治区" },
    { "id": "43", "name": "湖南省" },
    { "id": "61", "name": "陕西省" },
    { "id": "44", "name": "广东省" },
    { "id": "22", "name": "吉林省" },
    { "id": "13", "name": "河北省" },
    { "id": "42", "name": "湖北省" },
    { "id": "52", "name": "贵州省" },
    { "id": "37", "name": "山东省" },
    { "id": "36", "name": "江西省" },
    { "id": "41", "name": "河南省" },
    { "id": "21", "name": "辽宁省" },
    { "id": "14", "name": "山西省" },
    { "id": "34", "name": "安徽省" },
    { "id": "35", "name": "福建省" },
    { "id": "33", "name": "浙江省" },
    { "id": "32", "name": "江苏省" },
    { "id": "50", "name": "重庆市" },
    { "id": "64", "name": "宁夏回族自治区" },
    { "id": "46", "name": "海南省" },
    { "id": "71", "name": "台湾省" },
    { "id": "11", "name": "北京市" },
    { "id": "12", "name": "天津市" },
    { "id": "31", "name": "上海市" },
    { "id": "81", "name": "香港特别行政区" },
    { "id": "82", "name": "澳门特别行政区" }
];
function mapPath(name, json) {
    var e_1, _a, e_2, _b;
    if (json === void 0) { json = null; }
    var id = name;
    if (json) {
        try {
            for (var _c = __values(json.features), _d = _c.next(); !_d.done; _d = _c.next()) {
                var feature = _d.value;
                if (feature.properties.id == name || feature.properties.name == name) {
                    var p = feature.properties.id + '';
                    if (p.length == 2) {
                        return '/images/province/' + p + '.json';
                    }
                    else if (p.length == 4) {
                        return '/images/city/' + p + '00.json';
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    else {
        try {
            for (var MAPIDS_1 = __values(MAPIDS), MAPIDS_1_1 = MAPIDS_1.next(); !MAPIDS_1_1.done; MAPIDS_1_1 = MAPIDS_1.next()) {
                var feature = MAPIDS_1_1.value;
                if (feature.id == name || feature.name == name) {
                    return '/images/province/' + feature.id + '.json';
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (MAPIDS_1_1 && !MAPIDS_1_1.done && (_b = MAPIDS_1.return)) _b.call(MAPIDS_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
    }
    return '';
}
exports.mapPath = mapPath;
