"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createNodes = void 0;
// export function wrap(text) {
//     text.each(function () {
//         var text = d3.select(this),
//             words = text.text().split(/\s+/).reverse(),
//             word,
//             line = [],
//             y = text.attr("y"),
//             x = text.attr("x"),
//             dy = parseFloat(text.attr("dy")),
//             tspan = text.text(null).append("tspan").attr("x", x).attr("y", y).attr("dy", dy + "em");
//         while (word = words.pop()) {
//             line.push(word);
//             tspan.text(line.join(" "));
//         }
//     });
// }//wrap	
function createNodes(numNodes, radius) {
    var nodes = [];
    var angle = Math.PI * 2 / numNodes;
    for (var i = 0; i < numNodes; i++) {
        var x = (radius * Math.cos(angle * i - Math.PI / 2)); // Calculate the x position of the element.
        var y = (radius * Math.sin(angle * i - Math.PI / 2)); // Calculate the y position of the element.
        nodes.push({ id: i, x: x, y: y });
    }
    return nodes;
}
exports.createNodes = createNodes;
