import * as React from 'react';
import { GridItemEvent } from './gridItem';
import { DragactProps, DragactState, DragactLayoutItem } from './dragact-type';
export declare class Dragact extends React.Component<DragactProps, DragactState> {
    constructor(props: DragactProps);
    onResizeStart: (layoutItem: GridItemEvent) => void;
    onResizing: (layoutItem: GridItemEvent) => void;
    onResizeEnd: (layoutItem: GridItemEvent) => void;
    onDragStart(bundles: GridItemEvent): void;
    onDrag(layoutItem: GridItemEvent): void;
    onDragEnd(layoutItem: GridItemEvent): void;
    renderPlaceholder(): JSX.Element;
    componentWillReceiveProps(nextProps: any): void;
    recalculateLayout: (layout: DragactLayoutItem[], col: number) => void;
    componentDidMount(): void;
    getGridItem(child: any, index: number): JSX.Element;
    render(): JSX.Element;
    getLayout(): DragactLayoutItem[];
    deleteItem(key: any): void;
}
