import { DragactLayoutItem, mapLayout } from "../dragact-type";
import { GridItemEvent } from "../gridItem";
/**
 * 把用户移动的块，标记为true
 * @param {*} layout
 * @param {*} key
 * @param {*} GridX
 * @param {*} GridY
 * @param {*} isUserMove
 */
export declare const syncLayout: (layout: mapLayout, movingItem: GridItemEvent) => mapLayout;
/**
 * 初始化的时候调用
 * 会把isUserMove和key一起映射到layout中
 * 不用用户设置
 * @param {*} layout
 * @param {*} children
 */
export declare const MapLayoutTostate: (layout: DragactLayoutItem[], children: any[]) => {
    isUserMove: boolean;
    key: any;
    static: any;
    GridX: number;
    GridY: number;
    w: number;
    h: number;
    handle?: Boolean;
    canDrag?: Boolean;
    canResize?: Boolean;
}[];
/**
 * 用key从layout中拿出item
 * @param {*} layout 输入进来的布局
 * @param {*} key
 */
export declare const layoutItemForkey: (layout: mapLayout, key: string) => DragactLayoutItem;
