"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEffectFunction = void 0;
var react_1 = require("react");
/**
 * 简写 useEffect 用于方法执行，不支持 Return (unmount), 默认没有 deps
 *
*/
var useEffectFunction = function (fn, deps) {
    if (deps === void 0) { deps = []; }
    (0, react_1.useEffect)(function () {
        fn();
    }, deps);
};
exports.useEffectFunction = useEffectFunction;
