"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFirstMountState = void 0;
var react_1 = require("react");
/**
 * 使用方法参考
 * https://github.com/streamich/react-use/blob/master/docs/useFirstMountState.md
*/
var useFirstMountState = function () {
    var isFirst = (0, react_1.useRef)(true);
    if (isFirst.current) {
        isFirst.current = false;
        return true;
    }
    return isFirst.current;
};
exports.useFirstMountState = useFirstMountState;
