/**
 * 使用方法参考
 * https://github.com/streamich/react-use/blob/master/docs/useSetState.md
 *
 * 扩展点 1： 支持返回 null ，返回  null 不渲染，性能增加
 * 扩展点 2： 支持 callBack
 *
*/
export declare const useSetState: <T extends object>(initialState?: T) => [T, (patch: Partial<T> | ((prevState: T) => Partial<T>), cb?: (nextState: T) => void) => void];
