"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VRowCol = void 0;
var React = require("react");
var _ = require("lodash");
var VRow_1 = require("./VRow");
var VCol_1 = require("./VCol");
var VRowCol = /** @class */ (function (_super) {
    __extends(VRowCol, _super);
    function VRowCol() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VRowCol.prototype.render = function () {
        var tmp = _.clone(this.props);
        var rowParam = { height: this.props.height };
        var colParam = {};
        if (_.has(tmp, 'height')) {
            rowParam.height = tmp.height;
            _.unset(tmp, 'height');
        }
        if (_.has(tmp, 'style')) {
            rowParam.style = tmp.style;
            _.unset(tmp, 'style');
        }
        if (_.has(tmp, 'className')) {
            rowParam.className = tmp.className;
            _.unset(tmp, 'className');
        }
        if (_.has(tmp, 'colClassName')) {
            colParam.className = tmp.colClassName;
            _.unset(tmp, 'colClassName');
        }
        if (_.has(tmp, 'colStyle')) {
            colParam.style = tmp.colStyle;
            _.unset(tmp, 'colStyle');
        }
        _.unset(tmp, 'children');
        return React.createElement(VRow_1.VRow, __assign({}, rowParam),
            React.createElement(VCol_1.VCol, __assign({}, tmp, colParam), this.props.children));
    };
    return VRowCol;
}(React.PureComponent));
exports.VRowCol = VRowCol;
