"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * antd 支持内置的 ICON
 *  */
window['IconList'] = ["account-book", "alert", "api", "audio", "appstore", "bank", "bell", "book", "build", "bulb", "box-plot", "calculator", "car", "camera", "carry-out", "check-circle", "check-square", "clock-circle", "close-circle", "close-square", "cloud", "code", "compass", "contacts", "container", "control", "copy", "credit-card", "crown", "dashboard", "customer-service", "delete", "database", "diff", "dislike", "down-circle", "down-square", "edit", "environment", "exclamation-circle", "eye-invisible", "experiment", "eye", "file-add", "file-excel", "file-image", "file-exclamation", "file-markdown", "file-pdf", "file-word", "file-unknown", "file-ppt", "file-zip", "file-text", "filter", "file", "fire", "flag", "folder", "folder-open", "folder-add", "fund", "frown", "funnel-plot", "gift", "highlight", "hdd", "heart", "home", "html5", "idcard", "hourglass", "info-circle", "insurance", "interation", "layout", "left-circle", "left-square", "like", "mail", "medicine-box", "meh", "lock", "message", "minus-square", "minus-circle", "mobile", "money-collect", "picture", "notification", "pause-circle", "pie-chart", "play-circle", "phone", "play-square", "plus-circle", "plus-square", "profile", "project", "printer", "property-safety", "pushpin", "question-circle", "reconciliation", "red-envelope", "right-square", "rocket", "rest", "right-circle", "safety-certificate", "save", "schedule", "security-scan", "shop", "setting", "shopping", "skin", "sliders", "smile", "snippets", "star", "sound", "tablet", "switcher", "tag", "stop", "tags", "tool", "thunderbolt", "trophy", "up-circle", "unlock", "usb", "up-square", "video-camera", "warning", "wallet"];
// export const AntList = ["account-book", "alert", "api", "audio", "appstore", "bank", "bell", "book", "build", "bulb", "box-plot", "calculator", "car", "camera", "carry-out", "check-circle", "check-square", "clock-circle", "close-circle", "close-square", "cloud", "code", "compass", "contacts", "container", "control", "copy", "credit-card", "crown", "dashboard", "customer-service", "delete", "database", "diff", "dislike", "down-circle", "down-square", "edit", "environment", "exclamation-circle", "eye-invisible", "experiment", "eye", "file-add", "file-excel", "file-image", "file-exclamation", "file-markdown", "file-pdf", "file-word", "file-unknown", "file-ppt", "file-zip", "file-text", "filter", "file", "fire", "flag", "folder", "folder-open", "folder-add", "fund", "frown", "funnel-plot", "gift", "highlight", "hdd", "heart", "home", "html5", "idcard", "hourglass", "info-circle", "insurance", "interation", "layout", "left-circle", "left-square", "like", "mail", "medicine-box", "meh", "lock", "message", "minus-square", "minus-circle", "mobile", "money-collect", "picture", "notification", "pause-circle", "pie-chart", "play-circle", "phone", "play-square", "plus-circle", "plus-square", "profile", "project", "printer", "property-safety", "pushpin", "question-circle", "reconciliation", "red-envelope", "right-square", "rocket", "rest", "right-circle", "safety-certificate", "save", "schedule", "security-scan", "shop", "setting", "shopping", "skin", "sliders", "smile", "snippets", "star", "sound", "tablet", "switcher", "tag", "stop", "tags", "tool", "thunderbolt", "trophy", "up-circle", "unlock", "usb", "up-square", "video-camera", "warning", "wallet"];
/**
 * 扩展的 Icon (需要通过 IconUtil.register方法进行扩展，一般去 https://iconfont.cn/ 获取扩展资源)
 *   */
window['ExtraList'] = window['ExtraList'] || [];
/**
 * 扩展Map
 *   */
window['ExtarMap'] = window['ExtarMap'] || new Map();
/**
 * 注册扩展ICON，需要先通过工具提取unicode
 *   */
window['registerIcon'] = function (className, uniCode) {
    window['ExtarMap'].set(className, uniCode);
    window['ExtraList'].push(className);
    window['IconList'].push(className);
};
/**
 * 通过className 获取 unicode
 *   */
window['iconUnicode'] = function (fontClass) {
    if (window['ExtarMap'].has(fontClass)) {
        return window['ExtarMap'].get(fontClass);
    }
    return '';
};
var name = /** @class */ (function () {
    function name() {
    }
    name.IconList = window['IconList'];
    name.ExtraList = window['ExtraList'];
    name.register = window['registerIcon'];
    name.iconUnicode = window['iconUnicode'];
    return name;
}());
exports.default = name;
